package //
// This software is now distributed according to
// the Lesser Gnu Public License.  Please see
// http://www.gnu.org/copyleft/lesser.txt for
// the details.
//    -- Happy Computing!
//
    com.stevesoft.pat;

public class Bits
{
  char[] carray;
  Bits(char[] carray)
  {
    this.carray = carray;
  }

  public boolean get(int i)
  {
    return ( (carray[i >> 4]) & (1 << (i & 15))) != 0;
  }

  public void set(int i, boolean b)
  {
    if (b)
    {
      carray[i >> 4] |= (char) 1 << (i & 15);
    }
    else
    {
      carray[i >> 4] &= (char)~ (1 << (i & 15));
    }
  }

  /*
     public static String n4(char c) {
    String s = Integer.toHexString(c);
    while(s.length()<4)
      s = "0"+s;
    return s;
     }
     static abstract class Tester {
    abstract boolean test(char c);
     }
     public static void main(String[] args) throws Exception {
    //pw_s.println("  static {");
    FileWriter fw = new FileWriter("x.out");
    fw.close();
    test("upper",new Tester() {
      boolean test(char c) {
        return Character.isUpperCase(c);
      }
    });
    test("lower",new Tester() {
      boolean test(char c) {
        return Character.isLowerCase(c);
      }
    });
    test("title",new Tester() {
      boolean test(char c) {
        return Character.isLowerCase(c);
      }
    });
    test("currency",new Tester() {
      boolean test(char c) {
        return Character.getType(c)==Character.CURRENCY_SYMBOL;
      }
    });
    test("decimal_digit",new Tester() {
      boolean test(char c) {
        return Character.getType(c)==Character.DECIMAL_DIGIT_NUMBER;
      }
    });
    test("math",new Tester() {
      boolean test(char c) {
        return Character.getType(c)==Character.MATH_SYMBOL;
      }
    });
    test("letter",new Tester() {
      boolean test(char c) {
        return Character.isLetter(c);
      }
    });
    test("white",new Tester() {
      boolean test(char c) {
        return Character.isWhitespace(c);
      }
    });
    test("punct",new Tester() {
      boolean test(char c) {
    boolean r = false;
        switch(Character.getType(c)) {
        case Character.DASH_PUNCTUATION:
        case Character.START_PUNCTUATION:
        case Character.END_PUNCTUATION:
        case Character.CONNECTOR_PUNCTUATION:
        case Character.OTHER_PUNCTUATION:
   r = true;
   break;
    default:
   r = false;
   break;
    }
    return r;
      }
    });
    //pw_s.println("  }");
    fw = new FileWriter("x.out",true);
    fw.write(sw.toString());
    fw.close();
     }
     static StringWriter sw = new StringWriter();
     static PrintWriter pw_s = new PrintWriter(sw,true);
     public static void test(String var,Tester t) throws Exception {

    char[] ca = new char[(66536 >> 4)+1];
    Bits b = new Bits(ca);
    FileWriter fw = new FileWriter("x.out",true);
    PrintWriter pw = new PrintWriter(fw);

    //pw_s.println("    "+var+"_f();");
    pw.println("  public static Bits "+var+";");
    pw.println("  static void "+var+"_f() {");
    pw.println("    char[] data = new char["+ca.length+"];");
    pw.println("    "+var+" = new Bits(data);");
    for(int i=0;i<66536;i++) {
      char c = (char)i;
      //b.set(i,Character.getType(c)==Character.CURRENCY_SYMBOL);
      b.set(i,t.test(c));
    }
    for(int i=0;i<ca.length;i++) {
      if(ca[i] != 0) {
        pw.println("    data["+i+"]=(char)0x"+n4(ca[i])+";");
      }
    }
    pw.println();
    pw.println("  }");

    pw.close();
     }
   */
  public static Bits upper;
  static void upper_f()
  {
    char[] data = new char[4159];
    upper = new Bits(data);
    data[4] = (char) 0xfffe;
    data[5] = (char) 0x07ff;
    data[12] = (char) 0xffff;
    data[13] = (char) 0x7f7f;
    data[16] = (char) 0x5555;
    data[17] = (char) 0x5555;
    data[18] = (char) 0x5555;
    data[19] = (char) 0xaa55;
    data[20] = (char) 0x54aa;
    data[21] = (char) 0x5555;
    data[22] = (char) 0x5555;
    data[23] = (char) 0x2b55;
    data[24] = (char) 0xced6;
    data[25] = (char) 0xb1db;
    data[26] = (char) 0xd2d5;
    data[27] = (char) 0x11ae;
    data[28] = (char) 0xa490;
    data[29] = (char) 0x4aaa;
    data[30] = (char) 0x5555;
    data[31] = (char) 0x5412;
    data[32] = (char) 0x5555;
    data[33] = (char) 0x0055;
    data[56] = (char) 0xd740;
    data[57] = (char) 0xfffe;
    data[58] = (char) 0x0ffb;
    data[61] = (char) 0x541c;
    data[62] = (char) 0x5555;
    data[64] = (char) 0xdffe;
    data[65] = (char) 0xffff;
    data[66] = (char) 0xffff;
    data[70] = (char) 0x5555;
    data[71] = (char) 0x5555;
    data[72] = (char) 0x0001;
    data[73] = (char) 0x5555;
    data[74] = (char) 0x5555;
    data[75] = (char) 0x5555;
    data[76] = (char) 0x088a;
    data[77] = (char) 0x5555;
    data[78] = (char) 0x4555;
    data[79] = (char) 0x0115;
    data[83] = (char) 0xfffe;
    data[84] = (char) 0xffff;
    data[85] = (char) 0x007f;
    data[266] = (char) 0xffff;
    data[267] = (char) 0xffff;
    data[268] = (char) 0x003f;
    data[480] = (char) 0x5555;
    data[481] = (char) 0x5555;
    data[482] = (char) 0x5555;
    data[483] = (char) 0x5555;
    data[484] = (char) 0x5555;
    data[485] = (char) 0x5555;
    data[486] = (char) 0x5555;
    data[487] = (char) 0x5555;
    data[488] = (char) 0x5555;
    data[489] = (char) 0x0015;
    data[490] = (char) 0x5555;
    data[491] = (char) 0x5555;
    data[492] = (char) 0x5555;
    data[493] = (char) 0x5555;
    data[494] = (char) 0x5555;
    data[495] = (char) 0x0155;
    data[496] = (char) 0xff00;
    data[497] = (char) 0x3f00;
    data[498] = (char) 0xff00;
    data[499] = (char) 0xff00;
    data[500] = (char) 0x3f00;
    data[501] = (char) 0xaa00;
    data[502] = (char) 0xff00;
    data[504] = (char) 0xff00;
    data[505] = (char) 0xff00;
    data[506] = (char) 0xff00;
    data[507] = (char) 0x5f00;
    data[508] = (char) 0x1f00;
    data[509] = (char) 0x0f00;
    data[510] = (char) 0x1f00;
    data[511] = (char) 0x1f00;
    data[528] = (char) 0x3884;
    data[529] = (char) 0x3f27;
    data[530] = (char) 0x3d50;
    data[531] = (char) 0x000b;
    data[4082] = (char) 0xfffe;
    data[4083] = (char) 0x07ff;
    data[4100] = (char) 0xfffe;
    data[4101] = (char) 0x07ff;
    data[4108] = (char) 0xffff;
    data[4109] = (char) 0x7f7f;
    data[4112] = (char) 0x5555;
    data[4113] = (char) 0x5555;
    data[4114] = (char) 0x5555;
    data[4115] = (char) 0xaa55;
    data[4116] = (char) 0x54aa;
    data[4117] = (char) 0x5555;
    data[4118] = (char) 0x5555;
    data[4119] = (char) 0x2b55;
    data[4120] = (char) 0xced6;
    data[4121] = (char) 0xb1db;
    data[4122] = (char) 0xd2d5;
    data[4123] = (char) 0x11ae;
    data[4124] = (char) 0xa490;
    data[4125] = (char) 0x4aaa;
    data[4126] = (char) 0x5555;
    data[4127] = (char) 0x5412;
    data[4128] = (char) 0x5555;
    data[4129] = (char) 0x0055;
    data[4152] = (char) 0xd740;
    data[4153] = (char) 0xfffe;
    data[4154] = (char) 0x0ffb;
    data[4157] = (char) 0x541c;
    data[4158] = (char) 0x0055;

  }

  public static Bits lower;
  static void lower_f()
  {
    char[] data = new char[4159];
    lower = new Bits(data);
    data[6] = (char) 0xfffe;
    data[7] = (char) 0x07ff;
    data[10] = (char) 0x0400;
    data[11] = (char) 0x0420;
    data[13] = (char) 0x8000;
    data[14] = (char) 0xffff;
    data[15] = (char) 0xff7f;
    data[16] = (char) 0xaaaa;
    data[17] = (char) 0xaaaa;
    data[18] = (char) 0xaaaa;
    data[19] = (char) 0x55aa;
    data[20] = (char) 0xab55;
    data[21] = (char) 0xaaaa;
    data[22] = (char) 0xaaaa;
    data[23] = (char) 0xd4aa;
    data[24] = (char) 0x3129;
    data[25] = (char) 0x4e24;
    data[26] = (char) 0x292a;
    data[27] = (char) 0x2651;
    data[28] = (char) 0x5240;
    data[29] = (char) 0xb555;
    data[30] = (char) 0xaaaa;
    data[31] = (char) 0xa829;
    data[32] = (char) 0xaaaa;
    data[33] = (char) 0x00aa;
    data[37] = (char) 0xffff;
    data[38] = (char) 0xffff;
    data[39] = (char) 0xffff;
    data[40] = (char) 0xffff;
    data[41] = (char) 0xffff;
    data[42] = (char) 0x01ff;
    data[57] = (char) 0x0001;
    data[58] = (char) 0xf000;
    data[59] = (char) 0xffff;
    data[60] = (char) 0x7fff;
    data[61] = (char) 0x0063;
    data[62] = (char) 0xaaa8;
    data[63] = (char) 0x0007;
    data[67] = (char) 0xffff;
    data[68] = (char) 0xffff;
    data[69] = (char) 0xdffe;
    data[70] = (char) 0xaaaa;
    data[71] = (char) 0xaaaa;
    data[72] = (char) 0x0002;
    data[73] = (char) 0xaaaa;
    data[74] = (char) 0xaaaa;
    data[75] = (char) 0xaaaa;
    data[76] = (char) 0x1114;
    data[77] = (char) 0xaaaa;
    data[78] = (char) 0x8aaa;
    data[79] = (char) 0x022a;
    data[86] = (char) 0xfffe;
    data[87] = (char) 0xffff;
    data[88] = (char) 0x00ff;
    data[269] = (char) 0xffff;
    data[270] = (char) 0xffff;
    data[271] = (char) 0x007f;
    data[480] = (char) 0xaaaa;
    data[481] = (char) 0xaaaa;
    data[482] = (char) 0xaaaa;
    data[483] = (char) 0xaaaa;
    data[484] = (char) 0xaaaa;
    data[485] = (char) 0xaaaa;
    data[486] = (char) 0xaaaa;
    data[487] = (char) 0xaaaa;
    data[488] = (char) 0xaaaa;
    data[489] = (char) 0x0fea;
    data[490] = (char) 0xaaaa;
    data[491] = (char) 0xaaaa;
    data[492] = (char) 0xaaaa;
    data[493] = (char) 0xaaaa;
    data[494] = (char) 0xaaaa;
    data[495] = (char) 0x02aa;
    data[496] = (char) 0x00ff;
    data[497] = (char) 0x003f;
    data[498] = (char) 0x00ff;
    data[499] = (char) 0x00ff;
    data[500] = (char) 0x003f;
    data[501] = (char) 0x00ff;
    data[502] = (char) 0x00ff;
    data[503] = (char) 0x3fff;
    data[504] = (char) 0x00ff;
    data[505] = (char) 0x00ff;
    data[506] = (char) 0x00ff;
    data[507] = (char) 0x00df;
    data[508] = (char) 0x00dc;
    data[509] = (char) 0x00cf;
    data[510] = (char) 0x00ff;
    data[511] = (char) 0x00dc;
    data[519] = (char) 0x8000;
    data[528] = (char) 0xc400;
    data[529] = (char) 0x0008;
    data[530] = (char) 0xc000;
    data[531] = (char) 0x0010;
    data[4016] = (char) 0x007f;
    data[4017] = (char) 0x00f8;
    data[4084] = (char) 0xfffe;
    data[4085] = (char) 0x07ff;
    data[4102] = (char) 0xfffe;
    data[4103] = (char) 0x07ff;
    data[4106] = (char) 0x0400;
    data[4107] = (char) 0x0420;
    data[4109] = (char) 0x8000;
    data[4110] = (char) 0xffff;
    data[4111] = (char) 0xff7f;
    data[4112] = (char) 0xaaaa;
    data[4113] = (char) 0xaaaa;
    data[4114] = (char) 0xaaaa;
    data[4115] = (char) 0x55aa;
    data[4116] = (char) 0xab55;
    data[4117] = (char) 0xaaaa;
    data[4118] = (char) 0xaaaa;
    data[4119] = (char) 0xd4aa;
    data[4120] = (char) 0x3129;
    data[4121] = (char) 0x4e24;
    data[4122] = (char) 0x292a;
    data[4123] = (char) 0x2651;
    data[4124] = (char) 0x5240;
    data[4125] = (char) 0xb555;
    data[4126] = (char) 0xaaaa;
    data[4127] = (char) 0xa829;
    data[4128] = (char) 0xaaaa;
    data[4129] = (char) 0x00aa;
    data[4133] = (char) 0xffff;
    data[4134] = (char) 0xffff;
    data[4135] = (char) 0xffff;
    data[4136] = (char) 0xffff;
    data[4137] = (char) 0xffff;
    data[4138] = (char) 0x01ff;
    data[4153] = (char) 0x0001;
    data[4154] = (char) 0xf000;
    data[4155] = (char) 0xffff;
    data[4156] = (char) 0x7fff;
    data[4157] = (char) 0x0063;
    data[4158] = (char) 0x00a8;

  }

  public static Bits title;
  static void title_f()
  {
    char[] data = new char[4159];
    title = new Bits(data);
    data[6] = (char) 0xfffe;
    data[7] = (char) 0x07ff;
    data[10] = (char) 0x0400;
    data[11] = (char) 0x0420;
    data[13] = (char) 0x8000;
    data[14] = (char) 0xffff;
    data[15] = (char) 0xff7f;
    data[16] = (char) 0xaaaa;
    data[17] = (char) 0xaaaa;
    data[18] = (char) 0xaaaa;
    data[19] = (char) 0x55aa;
    data[20] = (char) 0xab55;
    data[21] = (char) 0xaaaa;
    data[22] = (char) 0xaaaa;
    data[23] = (char) 0xd4aa;
    data[24] = (char) 0x3129;
    data[25] = (char) 0x4e24;
    data[26] = (char) 0x292a;
    data[27] = (char) 0x2651;
    data[28] = (char) 0x5240;
    data[29] = (char) 0xb555;
    data[30] = (char) 0xaaaa;
    data[31] = (char) 0xa829;
    data[32] = (char) 0xaaaa;
    data[33] = (char) 0x00aa;
    data[37] = (char) 0xffff;
    data[38] = (char) 0xffff;
    data[39] = (char) 0xffff;
    data[40] = (char) 0xffff;
    data[41] = (char) 0xffff;
    data[42] = (char) 0x01ff;
    data[57] = (char) 0x0001;
    data[58] = (char) 0xf000;
    data[59] = (char) 0xffff;
    data[60] = (char) 0x7fff;
    data[61] = (char) 0x0063;
    data[62] = (char) 0xaaa8;
    data[63] = (char) 0x0007;
    data[67] = (char) 0xffff;
    data[68] = (char) 0xffff;
    data[69] = (char) 0xdffe;
    data[70] = (char) 0xaaaa;
    data[71] = (char) 0xaaaa;
    data[72] = (char) 0x0002;
    data[73] = (char) 0xaaaa;
    data[74] = (char) 0xaaaa;
    data[75] = (char) 0xaaaa;
    data[76] = (char) 0x1114;
    data[77] = (char) 0xaaaa;
    data[78] = (char) 0x8aaa;
    data[79] = (char) 0x022a;
    data[86] = (char) 0xfffe;
    data[87] = (char) 0xffff;
    data[88] = (char) 0x00ff;
    data[269] = (char) 0xffff;
    data[270] = (char) 0xffff;
    data[271] = (char) 0x007f;
    data[480] = (char) 0xaaaa;
    data[481] = (char) 0xaaaa;
    data[482] = (char) 0xaaaa;
    data[483] = (char) 0xaaaa;
    data[484] = (char) 0xaaaa;
    data[485] = (char) 0xaaaa;
    data[486] = (char) 0xaaaa;
    data[487] = (char) 0xaaaa;
    data[488] = (char) 0xaaaa;
    data[489] = (char) 0x0fea;
    data[490] = (char) 0xaaaa;
    data[491] = (char) 0xaaaa;
    data[492] = (char) 0xaaaa;
    data[493] = (char) 0xaaaa;
    data[494] = (char) 0xaaaa;
    data[495] = (char) 0x02aa;
    data[496] = (char) 0x00ff;
    data[497] = (char) 0x003f;
    data[498] = (char) 0x00ff;
    data[499] = (char) 0x00ff;
    data[500] = (char) 0x003f;
    data[501] = (char) 0x00ff;
    data[502] = (char) 0x00ff;
    data[503] = (char) 0x3fff;
    data[504] = (char) 0x00ff;
    data[505] = (char) 0x00ff;
    data[506] = (char) 0x00ff;
    data[507] = (char) 0x00df;
    data[508] = (char) 0x00dc;
    data[509] = (char) 0x00cf;
    data[510] = (char) 0x00ff;
    data[511] = (char) 0x00dc;
    data[519] = (char) 0x8000;
    data[528] = (char) 0xc400;
    data[529] = (char) 0x0008;
    data[530] = (char) 0xc000;
    data[531] = (char) 0x0010;
    data[4016] = (char) 0x007f;
    data[4017] = (char) 0x00f8;
    data[4084] = (char) 0xfffe;
    data[4085] = (char) 0x07ff;
    data[4102] = (char) 0xfffe;
    data[4103] = (char) 0x07ff;
    data[4106] = (char) 0x0400;
    data[4107] = (char) 0x0420;
    data[4109] = (char) 0x8000;
    data[4110] = (char) 0xffff;
    data[4111] = (char) 0xff7f;
    data[4112] = (char) 0xaaaa;
    data[4113] = (char) 0xaaaa;
    data[4114] = (char) 0xaaaa;
    data[4115] = (char) 0x55aa;
    data[4116] = (char) 0xab55;
    data[4117] = (char) 0xaaaa;
    data[4118] = (char) 0xaaaa;
    data[4119] = (char) 0xd4aa;
    data[4120] = (char) 0x3129;
    data[4121] = (char) 0x4e24;
    data[4122] = (char) 0x292a;
    data[4123] = (char) 0x2651;
    data[4124] = (char) 0x5240;
    data[4125] = (char) 0xb555;
    data[4126] = (char) 0xaaaa;
    data[4127] = (char) 0xa829;
    data[4128] = (char) 0xaaaa;
    data[4129] = (char) 0x00aa;
    data[4133] = (char) 0xffff;
    data[4134] = (char) 0xffff;
    data[4135] = (char) 0xffff;
    data[4136] = (char) 0xffff;
    data[4137] = (char) 0xffff;
    data[4138] = (char) 0x01ff;
    data[4153] = (char) 0x0001;
    data[4154] = (char) 0xf000;
    data[4155] = (char) 0xffff;
    data[4156] = (char) 0x7fff;
    data[4157] = (char) 0x0063;
    data[4158] = (char) 0x00a8;

  }

  public static Bits currency;
  static void currency_f()
  {
    char[] data = new char[4159];
    currency = new Bits(data);
    data[2] = (char) 0x0010;
    data[10] = (char) 0x003c;
    data[159] = (char) 0x000c;
    data[227] = (char) 0x8000;
    data[522] = (char) 0x1fff;
    data[4070] = (char) 0x0200;
    data[4080] = (char) 0x0010;
    data[4094] = (char) 0x0063;
    data[4098] = (char) 0x0010;
    data[4106] = (char) 0x003c;

  }

  public static Bits decimal_digit;
  static void decimal_digit_f()
  {
    char[] data = new char[4159];
    decimal_digit = new Bits(data);
    data[3] = (char) 0x03ff;
    data[102] = (char) 0x03ff;
    data[111] = (char) 0x03ff;
    data[150] = (char) 0xffc0;
    data[158] = (char) 0xffc0;
    data[166] = (char) 0xffc0;
    data[174] = (char) 0xffc0;
    data[182] = (char) 0xffc0;
    data[190] = (char) 0xff80;
    data[198] = (char) 0xffc0;
    data[206] = (char) 0xffc0;
    data[214] = (char) 0xffc0;
    data[229] = (char) 0x03ff;
    data[237] = (char) 0x03ff;
    data[242] = (char) 0x03ff;
    data[4081] = (char) 0x03ff;
    data[4099] = (char) 0x03ff;

  }

  public static Bits math;
  static void math_f()
  {
    char[] data = new char[4159];
    math = new Bits(data);
    data[2] = (char) 0x0800;
    data[3] = (char) 0x7000;
    data[7] = (char) 0x5000;
    data[10] = (char) 0x1000;
    data[11] = (char) 0x0002;
    data[13] = (char) 0x0080;
    data[15] = (char) 0x0080;
    data[516] = (char) 0x0010;
    data[519] = (char) 0x1c00;
    data[520] = (char) 0x1c00;
    data[537] = (char) 0x001f;
    data[541] = (char) 0x0014;
    data[544] = (char) 0xffff;
    data[545] = (char) 0xffff;
    data[546] = (char) 0xffff;
    data[547] = (char) 0xffff;
    data[548] = (char) 0xffff;
    data[549] = (char) 0xffff;
    data[550] = (char) 0xffff;
    data[551] = (char) 0xffff;
    data[552] = (char) 0xffff;
    data[553] = (char) 0xffff;
    data[554] = (char) 0xffff;
    data[555] = (char) 0xffff;
    data[556] = (char) 0xffff;
    data[557] = (char) 0xffff;
    data[558] = (char) 0xffff;
    data[559] = (char) 0x0003;
    data[560] = (char) 0x0f00;
    data[562] = (char) 0x0003;
    data[4018] = (char) 0x0200;
    data[4070] = (char) 0x0074;
    data[4080] = (char) 0x0800;
    data[4081] = (char) 0x7000;
    data[4085] = (char) 0x5000;
    data[4094] = (char) 0x1f04;
    data[4098] = (char) 0x0800;
    data[4099] = (char) 0x7000;
    data[4103] = (char) 0x5000;
    data[4106] = (char) 0x1000;
    data[4107] = (char) 0x0002;
    data[4109] = (char) 0x0080;
    data[4111] = (char) 0x0080;

  }

  public static Bits letter;
  static void letter_f()
  {
    char[] data = new char[4159];
    letter = new Bits(data);
    data[4] = (char) 0xfffe;
    data[5] = (char) 0x07ff;
    data[6] = (char) 0xfffe;
    data[7] = (char) 0x07ff;
    data[10] = (char) 0x0400;
    data[11] = (char) 0x0420;
    data[12] = (char) 0xffff;
    data[13] = (char) 0xff7f;
    data[14] = (char) 0xffff;
    data[15] = (char) 0xff7f;
    data[16] = (char) 0xffff;
    data[17] = (char) 0xffff;
    data[18] = (char) 0xffff;
    data[19] = (char) 0xffff;
    data[20] = (char) 0xffff;
    data[21] = (char) 0xffff;
    data[22] = (char) 0xffff;
    data[23] = (char) 0xffff;
    data[24] = (char) 0xffff;
    data[25] = (char) 0xffff;
    data[26] = (char) 0xffff;
    data[27] = (char) 0xffff;
    data[28] = (char) 0xffff;
    data[29] = (char) 0xffff;
    data[30] = (char) 0xffff;
    data[31] = (char) 0xfc3f;
    data[32] = (char) 0xffff;
    data[33] = (char) 0x00ff;
    data[37] = (char) 0xffff;
    data[38] = (char) 0xffff;
    data[39] = (char) 0xffff;
    data[40] = (char) 0xffff;
    data[41] = (char) 0xffff;
    data[42] = (char) 0x01ff;
    data[43] = (char) 0xf9ff;
    data[44] = (char) 0x0003;
    data[45] = (char) 0x0003;
    data[46] = (char) 0x001f;
    data[55] = (char) 0x0400;
    data[56] = (char) 0xd740;
    data[57] = (char) 0xffff;
    data[58] = (char) 0xfffb;
    data[59] = (char) 0xffff;
    data[60] = (char) 0x7fff;
    data[61] = (char) 0x547f;
    data[62] = (char) 0xfffd;
    data[63] = (char) 0x000f;
    data[64] = (char) 0xdffe;
    data[65] = (char) 0xffff;
    data[66] = (char) 0xffff;
    data[67] = (char) 0xffff;
    data[68] = (char) 0xffff;
    data[69] = (char) 0xdffe;
    data[70] = (char) 0xffff;
    data[71] = (char) 0xffff;
    data[72] = (char) 0x0003;
    data[73] = (char) 0xffff;
    data[74] = (char) 0xffff;
    data[75] = (char) 0xffff;
    data[76] = (char) 0x199f;
    data[77] = (char) 0xffff;
    data[78] = (char) 0xcfff;
    data[79] = (char) 0x033f;
    data[83] = (char) 0xfffe;
    data[84] = (char) 0xffff;
    data[85] = (char) 0x027f;
    data[86] = (char) 0xfffe;
    data[87] = (char) 0xffff;
    data[88] = (char) 0x00ff;
    data[93] = (char) 0xffff;
    data[94] = (char) 0x07ff;
    data[95] = (char) 0x0007;
    data[98] = (char) 0xfffe;
    data[99] = (char) 0x07ff;
    data[100] = (char) 0x07ff;
    data[103] = (char) 0xfffe;
    data[104] = (char) 0xffff;
    data[105] = (char) 0xffff;
    data[106] = (char) 0xffff;
    data[107] = (char) 0x7cff;
    data[108] = (char) 0x7fff;
    data[109] = (char) 0x002f;
    data[110] = (char) 0x0060;
    data[144] = (char) 0xffe0;
    data[145] = (char) 0xffff;
    data[146] = (char) 0xffff;
    data[147] = (char) 0x23ff;
    data[149] = (char) 0xff00;
    data[150] = (char) 0x0003;
    data[152] = (char) 0x9fe0;
    data[153] = (char) 0xfff9;
    data[154] = (char) 0xfdff;
    data[155] = (char) 0x03c5;
    data[157] = (char) 0xb000;
    data[158] = (char) 0x0003;
    data[159] = (char) 0x0003;
    data[160] = (char) 0x87e0;
    data[161] = (char) 0xfff9;
    data[162] = (char) 0xfdff;
    data[163] = (char) 0x036d;
    data[165] = (char) 0x5e00;
    data[167] = (char) 0x001c;
    data[168] = (char) 0xafe0;
    data[169] = (char) 0xfffb;
    data[170] = (char) 0xfdff;
    data[171] = (char) 0x23ed;
    data[174] = (char) 0x0001;
    data[176] = (char) 0x9fe0;
    data[177] = (char) 0xfff9;
    data[178] = (char) 0xfdff;
    data[179] = (char) 0x23cd;
    data[181] = (char) 0xb000;
    data[182] = (char) 0x0003;
    data[184] = (char) 0xc7e0;
    data[185] = (char) 0xd63d;
    data[186] = (char) 0xc718;
    data[187] = (char) 0x03bf;
    data[192] = (char) 0xdfe0;
    data[193] = (char) 0xfffd;
    data[194] = (char) 0xfdff;
    data[195] = (char) 0x03ef;
    data[198] = (char) 0x0003;
    data[200] = (char) 0xdfe0;
    data[201] = (char) 0xfffd;
    data[202] = (char) 0xfdff;
    data[203] = (char) 0x03ef;
    data[205] = (char) 0x4000;
    data[206] = (char) 0x0003;
    data[208] = (char) 0xdfe0;
    data[209] = (char) 0xfffd;
    data[210] = (char) 0xfdff;
    data[211] = (char) 0x03ff;
    data[214] = (char) 0x0003;
    data[224] = (char) 0xfffe;
    data[225] = (char) 0xffff;
    data[226] = (char) 0x7fff;
    data[227] = (char) 0x000d;
    data[228] = (char) 0x007f;
    data[232] = (char) 0x2596;
    data[233] = (char) 0xfef0;
    data[234] = (char) 0x6cae;
    data[235] = (char) 0x200d;
    data[236] = (char) 0x005f;
    data[237] = (char) 0x3000;
    data[244] = (char) 0xfeff;
    data[245] = (char) 0xffff;
    data[246] = (char) 0x03ff;
    data[266] = (char) 0xffff;
    data[267] = (char) 0xffff;
    data[268] = (char) 0x003f;
    data[269] = (char) 0xffff;
    data[270] = (char) 0xffff;
    data[271] = (char) 0x007f;
    data[272] = (char) 0xffff;
    data[273] = (char) 0xffff;
    data[274] = (char) 0xffff;
    data[275] = (char) 0xffff;
    data[276] = (char) 0xffff;
    data[277] = (char) 0x83ff;
    data[278] = (char) 0xffff;
    data[279] = (char) 0xffff;
    data[280] = (char) 0xffff;
    data[281] = (char) 0xffff;
    data[282] = (char) 0xff07;
    data[283] = (char) 0xffff;
    data[284] = (char) 0xffff;
    data[285] = (char) 0xffff;
    data[286] = (char) 0xffff;
    data[287] = (char) 0x03ff;
    data[480] = (char) 0xffff;
    data[481] = (char) 0xffff;
    data[482] = (char) 0xffff;
    data[483] = (char) 0xffff;
    data[484] = (char) 0xffff;
    data[485] = (char) 0xffff;
    data[486] = (char) 0xffff;
    data[487] = (char) 0xffff;
    data[488] = (char) 0xffff;
    data[489] = (char) 0x0fff;
    data[490] = (char) 0xffff;
    data[491] = (char) 0xffff;
    data[492] = (char) 0xffff;
    data[493] = (char) 0xffff;
    data[494] = (char) 0xffff;
    data[495] = (char) 0x03ff;
    data[496] = (char) 0xffff;
    data[497] = (char) 0x3f3f;
    data[498] = (char) 0xffff;
    data[499] = (char) 0xffff;
    data[500] = (char) 0x3f3f;
    data[501] = (char) 0xaaff;
    data[502] = (char) 0xffff;
    data[503] = (char) 0x3fff;
    data[504] = (char) 0xffff;
    data[505] = (char) 0xffff;
    data[506] = (char) 0xffff;
    data[507] = (char) 0x5fdf;
    data[508] = (char) 0x1fdc;
    data[509] = (char) 0x0fcf;
    data[510] = (char) 0x1fff;
    data[511] = (char) 0x1fdc;
    data[519] = (char) 0x8000;
    data[528] = (char) 0xfc84;
    data[529] = (char) 0x3f2f;
    data[530] = (char) 0xfd50;
    data[531] = (char) 0x01fb;
    data[768] = (char) 0x0020;
    data[771] = (char) 0x003e;
    data[772] = (char) 0xfffe;
    data[773] = (char) 0xffff;
    data[774] = (char) 0xffff;
    data[775] = (char) 0xffff;
    data[776] = (char) 0xffff;
    data[777] = (char) 0x781f;
    data[778] = (char) 0xfffe;
    data[779] = (char) 0xffff;
    data[780] = (char) 0xffff;
    data[781] = (char) 0xffff;
    data[782] = (char) 0xffff;
    data[783] = (char) 0x77ff;
    data[784] = (char) 0xffe0;
    data[785] = (char) 0xffff;
    data[786] = (char) 0x1fff;
    data[787] = (char) 0xfffe;
    data[788] = (char) 0xffff;
    data[789] = (char) 0xffff;
    data[790] = (char) 0xffff;
    data[791] = (char) 0xffff;
    data[792] = (char) 0x7fff;
    data[1248] = (char) 0xffff;
    data[1249] = (char) 0xffff;
    data[1250] = (char) 0xffff;
    data[1251] = (char) 0xffff;
    data[1252] = (char) 0xffff;
    data[1253] = (char) 0xffff;
    data[1254] = (char) 0xffff;
    data[1255] = (char) 0xffff;
    data[1256] = (char) 0xffff;
    data[1257] = (char) 0xffff;
    data[1258] = (char) 0xffff;
    data[1259] = (char) 0xffff;
    data[1260] = (char) 0xffff;
    data[1261] = (char) 0xffff;
    data[1262] = (char) 0xffff;
    data[1263] = (char) 0xffff;
    data[1264] = (char) 0xffff;
    data[1265] = (char) 0xffff;
    data[1266] = (char) 0xffff;
    data[1267] = (char) 0xffff;
    data[1268] = (char) 0xffff;
    data[1269] = (char) 0xffff;
    data[1270] = (char) 0xffff;
    data[1271] = (char) 0xffff;
    data[1272] = (char) 0xffff;
    data[1273] = (char) 0xffff;
    data[1274] = (char) 0xffff;
    data[1275] = (char) 0xffff;
    data[1276] = (char) 0xffff;
    data[1277] = (char) 0xffff;
    data[1278] = (char) 0xffff;
    data[1279] = (char) 0xffff;
    data[1280] = (char) 0xffff;
    data[1281] = (char) 0xffff;
    data[1282] = (char) 0xffff;
    data[1283] = (char) 0xffff;
    data[1284] = (char) 0xffff;
    data[1285] = (char) 0xffff;
    data[1286] = (char) 0xffff;
    data[1287] = (char) 0xffff;
    data[1288] = (char) 0xffff;
    data[1289] = (char) 0xffff;
    data[1290] = (char) 0xffff;
    data[1291] = (char) 0xffff;
    data[1292] = (char) 0xffff;
    data[1293] = (char) 0xffff;
    data[1294] = (char) 0xffff;
    data[1295] = (char) 0xffff;
    data[1296] = (char) 0xffff;
    data[1297] = (char) 0xffff;
    data[1298] = (char) 0xffff;
    data[1299] = (char) 0xffff;
    data[1300] = (char) 0xffff;
    data[1301] = (char) 0xffff;
    data[1302] = (char) 0xffff;
    data[1303] = (char) 0xffff;
    data[1304] = (char) 0xffff;
    data[1305] = (char) 0xffff;
    data[1306] = (char) 0xffff;
    data[1307] = (char) 0xffff;
    data[1308] = (char) 0xffff;
    data[1309] = (char) 0xffff;
    data[1310] = (char) 0xffff;
    data[1311] = (char) 0xffff;
    data[1312] = (char) 0xffff;
    data[1313] = (char) 0xffff;
    data[1314] = (char) 0xffff;
    data[1315] = (char) 0xffff;
    data[1316] = (char) 0xffff;
    data[1317] = (char) 0xffff;
    data[1318] = (char) 0xffff;
    data[1319] = (char) 0xffff;
    data[1320] = (char) 0xffff;
    data[1321] = (char) 0xffff;
    data[1322] = (char) 0xffff;
    data[1323] = (char) 0xffff;
    data[1324] = (char) 0xffff;
    data[1325] = (char) 0xffff;
    data[1326] = (char) 0xffff;
    data[1327] = (char) 0xffff;
    data[1328] = (char) 0xffff;
    data[1329] = (char) 0xffff;
    data[1330] = (char) 0xffff;
    data[1331] = (char) 0xffff;
    data[1332] = (char) 0xffff;
    data[1333] = (char) 0xffff;
    data[1334] = (char) 0xffff;
    data[1335] = (char) 0xffff;
    data[1336] = (char) 0xffff;
    data[1337] = (char) 0xffff;
    data[1338] = (char) 0xffff;
    data[1339] = (char) 0xffff;
    data[1340] = (char) 0xffff;
    data[1341] = (char) 0xffff;
    data[1342] = (char) 0xffff;
    data[1343] = (char) 0xffff;
    data[1344] = (char) 0xffff;
    data[1345] = (char) 0xffff;
    data[1346] = (char) 0xffff;
    data[1347] = (char) 0xffff;
    data[1348] = (char) 0xffff;
    data[1349] = (char) 0xffff;
    data[1350] = (char) 0xffff;
    data[1351] = (char) 0xffff;
    data[1352] = (char) 0xffff;
    data[1353] = (char) 0xffff;
    data[1354] = (char) 0xffff;
    data[1355] = (char) 0xffff;
    data[1356] = (char) 0xffff;
    data[1357] = (char) 0xffff;
    data[1358] = (char) 0xffff;
    data[1359] = (char) 0xffff;
    data[1360] = (char) 0xffff;
    data[1361] = (char) 0xffff;
    data[1362] = (char) 0xffff;
    data[1363] = (char) 0xffff;
    data[1364] = (char) 0xffff;
    data[1365] = (char) 0xffff;
    data[1366] = (char) 0xffff;
    data[1367] = (char) 0xffff;
    data[1368] = (char) 0xffff;
    data[1369] = (char) 0xffff;
    data[1370] = (char) 0xffff;
    data[1371] = (char) 0xffff;
    data[1372] = (char) 0xffff;
    data[1373] = (char) 0xffff;
    data[1374] = (char) 0xffff;
    data[1375] = (char) 0xffff;
    data[1376] = (char) 0xffff;
    data[1377] = (char) 0xffff;
    data[1378] = (char) 0xffff;
    data[1379] = (char) 0xffff;
    data[1380] = (char) 0xffff;
    data[1381] = (char) 0xffff;
    data[1382] = (char) 0xffff;
    data[1383] = (char) 0xffff;
    data[1384] = (char) 0xffff;
    data[1385] = (char) 0xffff;
    data[1386] = (char) 0xffff;
    data[1387] = (char) 0xffff;
    data[1388] = (char) 0xffff;
    data[1389] = (char) 0xffff;
    data[1390] = (char) 0xffff;
    data[1391] = (char) 0xffff;
    data[1392] = (char) 0xffff;
    data[1393] = (char) 0xffff;
    data[1394] = (char) 0xffff;
    data[1395] = (char) 0xffff;
    data[1396] = (char) 0xffff;
    data[1397] = (char) 0xffff;
    data[1398] = (char) 0xffff;
    data[1399] = (char) 0xffff;
    data[1400] = (char) 0xffff;
    data[1401] = (char) 0xffff;
    data[1402] = (char) 0xffff;
    data[1403] = (char) 0xffff;
    data[1404] = (char) 0xffff;
    data[1405] = (char) 0xffff;
    data[1406] = (char) 0xffff;
    data[1407] = (char) 0xffff;
    data[1408] = (char) 0xffff;
    data[1409] = (char) 0xffff;
    data[1410] = (char) 0xffff;
    data[1411] = (char) 0xffff;
    data[1412] = (char) 0xffff;
    data[1413] = (char) 0xffff;
    data[1414] = (char) 0xffff;
    data[1415] = (char) 0xffff;
    data[1416] = (char) 0xffff;
    data[1417] = (char) 0xffff;
    data[1418] = (char) 0xffff;
    data[1419] = (char) 0xffff;
    data[1420] = (char) 0xffff;
    data[1421] = (char) 0xffff;
    data[1422] = (char) 0xffff;
    data[1423] = (char) 0xffff;
    data[1424] = (char) 0xffff;
    data[1425] = (char) 0xffff;
    data[1426] = (char) 0xffff;
    data[1427] = (char) 0xffff;
    data[1428] = (char) 0xffff;
    data[1429] = (char) 0xffff;
    data[1430] = (char) 0xffff;
    data[1431] = (char) 0xffff;
    data[1432] = (char) 0xffff;
    data[1433] = (char) 0xffff;
    data[1434] = (char) 0xffff;
    data[1435] = (char) 0xffff;
    data[1436] = (char) 0xffff;
    data[1437] = (char) 0xffff;
    data[1438] = (char) 0xffff;
    data[1439] = (char) 0xffff;
    data[1440] = (char) 0xffff;
    data[1441] = (char) 0xffff;
    data[1442] = (char) 0xffff;
    data[1443] = (char) 0xffff;
    data[1444] = (char) 0xffff;
    data[1445] = (char) 0xffff;
    data[1446] = (char) 0xffff;
    data[1447] = (char) 0xffff;
    data[1448] = (char) 0xffff;
    data[1449] = (char) 0xffff;
    data[1450] = (char) 0xffff;
    data[1451] = (char) 0xffff;
    data[1452] = (char) 0xffff;
    data[1453] = (char) 0xffff;
    data[1454] = (char) 0xffff;
    data[1455] = (char) 0xffff;
    data[1456] = (char) 0xffff;
    data[1457] = (char) 0xffff;
    data[1458] = (char) 0xffff;
    data[1459] = (char) 0xffff;
    data[1460] = (char) 0xffff;
    data[1461] = (char) 0xffff;
    data[1462] = (char) 0xffff;
    data[1463] = (char) 0xffff;
    data[1464] = (char) 0xffff;
    data[1465] = (char) 0xffff;
    data[1466] = (char) 0xffff;
    data[1467] = (char) 0xffff;
    data[1468] = (char) 0xffff;
    data[1469] = (char) 0xffff;
    data[1470] = (char) 0xffff;
    data[1471] = (char) 0xffff;
    data[1472] = (char) 0xffff;
    data[1473] = (char) 0xffff;
    data[1474] = (char) 0xffff;
    data[1475] = (char) 0xffff;
    data[1476] = (char) 0xffff;
    data[1477] = (char) 0xffff;
    data[1478] = (char) 0xffff;
    data[1479] = (char) 0xffff;
    data[1480] = (char) 0xffff;
    data[1481] = (char) 0xffff;
    data[1482] = (char) 0xffff;
    data[1483] = (char) 0xffff;
    data[1484] = (char) 0xffff;
    data[1485] = (char) 0xffff;
    data[1486] = (char) 0xffff;
    data[1487] = (char) 0xffff;
    data[1488] = (char) 0xffff;
    data[1489] = (char) 0xffff;
    data[1490] = (char) 0xffff;
    data[1491] = (char) 0xffff;
    data[1492] = (char) 0xffff;
    data[1493] = (char) 0xffff;
    data[1494] = (char) 0xffff;
    data[1495] = (char) 0xffff;
    data[1496] = (char) 0xffff;
    data[1497] = (char) 0xffff;
    data[1498] = (char) 0xffff;
    data[1499] = (char) 0xffff;
    data[1500] = (char) 0xffff;
    data[1501] = (char) 0xffff;
    data[1502] = (char) 0xffff;
    data[1503] = (char) 0xffff;
    data[1504] = (char) 0xffff;
    data[1505] = (char) 0xffff;
    data[1506] = (char) 0xffff;
    data[1507] = (char) 0xffff;
    data[1508] = (char) 0xffff;
    data[1509] = (char) 0xffff;
    data[1510] = (char) 0xffff;
    data[1511] = (char) 0xffff;
    data[1512] = (char) 0xffff;
    data[1513] = (char) 0xffff;
    data[1514] = (char) 0xffff;
    data[1515] = (char) 0xffff;
    data[1516] = (char) 0xffff;
    data[1517] = (char) 0xffff;
    data[1518] = (char) 0xffff;
    data[1519] = (char) 0xffff;
    data[1520] = (char) 0xffff;
    data[1521] = (char) 0xffff;
    data[1522] = (char) 0xffff;
    data[1523] = (char) 0xffff;
    data[1524] = (char) 0xffff;
    data[1525] = (char) 0xffff;
    data[1526] = (char) 0xffff;
    data[1527] = (char) 0xffff;
    data[1528] = (char) 0xffff;
    data[1529] = (char) 0xffff;
    data[1530] = (char) 0xffff;
    data[1531] = (char) 0xffff;
    data[1532] = (char) 0xffff;
    data[1533] = (char) 0xffff;
    data[1534] = (char) 0xffff;
    data[1535] = (char) 0xffff;
    data[1536] = (char) 0xffff;
    data[1537] = (char) 0xffff;
    data[1538] = (char) 0xffff;
    data[1539] = (char) 0xffff;
    data[1540] = (char) 0xffff;
    data[1541] = (char) 0xffff;
    data[1542] = (char) 0xffff;
    data[1543] = (char) 0xffff;
    data[1544] = (char) 0xffff;
    data[1545] = (char) 0xffff;
    data[1546] = (char) 0xffff;
    data[1547] = (char) 0xffff;
    data[1548] = (char) 0xffff;
    data[1549] = (char) 0xffff;
    data[1550] = (char) 0xffff;
    data[1551] = (char) 0xffff;
    data[1552] = (char) 0xffff;
    data[1553] = (char) 0xffff;
    data[1554] = (char) 0xffff;
    data[1555] = (char) 0xffff;
    data[1556] = (char) 0xffff;
    data[1557] = (char) 0xffff;
    data[1558] = (char) 0xffff;
    data[1559] = (char) 0xffff;
    data[1560] = (char) 0xffff;
    data[1561] = (char) 0xffff;
    data[1562] = (char) 0xffff;
    data[1563] = (char) 0xffff;
    data[1564] = (char) 0xffff;
    data[1565] = (char) 0xffff;
    data[1566] = (char) 0xffff;
    data[1567] = (char) 0xffff;
    data[1568] = (char) 0xffff;
    data[1569] = (char) 0xffff;
    data[1570] = (char) 0xffff;
    data[1571] = (char) 0xffff;
    data[1572] = (char) 0xffff;
    data[1573] = (char) 0xffff;
    data[1574] = (char) 0xffff;
    data[1575] = (char) 0xffff;
    data[1576] = (char) 0xffff;
    data[1577] = (char) 0xffff;
    data[1578] = (char) 0xffff;
    data[1579] = (char) 0xffff;
    data[1580] = (char) 0xffff;
    data[1581] = (char) 0xffff;
    data[1582] = (char) 0xffff;
    data[1583] = (char) 0xffff;
    data[1584] = (char) 0xffff;
    data[1585] = (char) 0xffff;
    data[1586] = (char) 0xffff;
    data[1587] = (char) 0xffff;
    data[1588] = (char) 0xffff;
    data[1589] = (char) 0xffff;
    data[1590] = (char) 0xffff;
    data[1591] = (char) 0xffff;
    data[1592] = (char) 0xffff;
    data[1593] = (char) 0xffff;
    data[1594] = (char) 0xffff;
    data[1595] = (char) 0xffff;
    data[1596] = (char) 0xffff;
    data[1597] = (char) 0xffff;
    data[1598] = (char) 0xffff;
    data[1599] = (char) 0xffff;
    data[1600] = (char) 0xffff;
    data[1601] = (char) 0xffff;
    data[1602] = (char) 0xffff;
    data[1603] = (char) 0xffff;
    data[1604] = (char) 0xffff;
    data[1605] = (char) 0xffff;
    data[1606] = (char) 0xffff;
    data[1607] = (char) 0xffff;
    data[1608] = (char) 0xffff;
    data[1609] = (char) 0xffff;
    data[1610] = (char) 0xffff;
    data[1611] = (char) 0xffff;
    data[1612] = (char) 0xffff;
    data[1613] = (char) 0xffff;
    data[1614] = (char) 0xffff;
    data[1615] = (char) 0xffff;
    data[1616] = (char) 0xffff;
    data[1617] = (char) 0xffff;
    data[1618] = (char) 0xffff;
    data[1619] = (char) 0xffff;
    data[1620] = (char) 0xffff;
    data[1621] = (char) 0xffff;
    data[1622] = (char) 0xffff;
    data[1623] = (char) 0xffff;
    data[1624] = (char) 0xffff;
    data[1625] = (char) 0xffff;
    data[1626] = (char) 0xffff;
    data[1627] = (char) 0xffff;
    data[1628] = (char) 0xffff;
    data[1629] = (char) 0xffff;
    data[1630] = (char) 0xffff;
    data[1631] = (char) 0xffff;
    data[1632] = (char) 0xffff;
    data[1633] = (char) 0xffff;
    data[1634] = (char) 0xffff;
    data[1635] = (char) 0xffff;
    data[1636] = (char) 0xffff;
    data[1637] = (char) 0xffff;
    data[1638] = (char) 0xffff;
    data[1639] = (char) 0xffff;
    data[1640] = (char) 0xffff;
    data[1641] = (char) 0xffff;
    data[1642] = (char) 0xffff;
    data[1643] = (char) 0xffff;
    data[1644] = (char) 0xffff;
    data[1645] = (char) 0xffff;
    data[1646] = (char) 0xffff;
    data[1647] = (char) 0xffff;
    data[1648] = (char) 0xffff;
    data[1649] = (char) 0xffff;
    data[1650] = (char) 0xffff;
    data[1651] = (char) 0xffff;
    data[1652] = (char) 0xffff;
    data[1653] = (char) 0xffff;
    data[1654] = (char) 0xffff;
    data[1655] = (char) 0xffff;
    data[1656] = (char) 0xffff;
    data[1657] = (char) 0xffff;
    data[1658] = (char) 0xffff;
    data[1659] = (char) 0xffff;
    data[1660] = (char) 0xffff;
    data[1661] = (char) 0xffff;
    data[1662] = (char) 0xffff;
    data[1663] = (char) 0xffff;
    data[1664] = (char) 0xffff;
    data[1665] = (char) 0xffff;
    data[1666] = (char) 0xffff;
    data[1667] = (char) 0xffff;
    data[1668] = (char) 0xffff;
    data[1669] = (char) 0xffff;
    data[1670] = (char) 0xffff;
    data[1671] = (char) 0xffff;
    data[1672] = (char) 0xffff;
    data[1673] = (char) 0xffff;
    data[1674] = (char) 0xffff;
    data[1675] = (char) 0xffff;
    data[1676] = (char) 0xffff;
    data[1677] = (char) 0xffff;
    data[1678] = (char) 0xffff;
    data[1679] = (char) 0xffff;
    data[1680] = (char) 0xffff;
    data[1681] = (char) 0xffff;
    data[1682] = (char) 0xffff;
    data[1683] = (char) 0xffff;
    data[1684] = (char) 0xffff;
    data[1685] = (char) 0xffff;
    data[1686] = (char) 0xffff;
    data[1687] = (char) 0xffff;
    data[1688] = (char) 0xffff;
    data[1689] = (char) 0xffff;
    data[1690] = (char) 0xffff;
    data[1691] = (char) 0xffff;
    data[1692] = (char) 0xffff;
    data[1693] = (char) 0xffff;
    data[1694] = (char) 0xffff;
    data[1695] = (char) 0xffff;
    data[1696] = (char) 0xffff;
    data[1697] = (char) 0xffff;
    data[1698] = (char) 0xffff;
    data[1699] = (char) 0xffff;
    data[1700] = (char) 0xffff;
    data[1701] = (char) 0xffff;
    data[1702] = (char) 0xffff;
    data[1703] = (char) 0xffff;
    data[1704] = (char) 0xffff;
    data[1705] = (char) 0xffff;
    data[1706] = (char) 0xffff;
    data[1707] = (char) 0xffff;
    data[1708] = (char) 0xffff;
    data[1709] = (char) 0xffff;
    data[1710] = (char) 0xffff;
    data[1711] = (char) 0xffff;
    data[1712] = (char) 0xffff;
    data[1713] = (char) 0xffff;
    data[1714] = (char) 0xffff;
    data[1715] = (char) 0xffff;
    data[1716] = (char) 0xffff;
    data[1717] = (char) 0xffff;
    data[1718] = (char) 0xffff;
    data[1719] = (char) 0xffff;
    data[1720] = (char) 0xffff;
    data[1721] = (char) 0xffff;
    data[1722] = (char) 0xffff;
    data[1723] = (char) 0xffff;
    data[1724] = (char) 0xffff;
    data[1725] = (char) 0xffff;
    data[1726] = (char) 0xffff;
    data[1727] = (char) 0xffff;
    data[1728] = (char) 0xffff;
    data[1729] = (char) 0xffff;
    data[1730] = (char) 0xffff;
    data[1731] = (char) 0xffff;
    data[1732] = (char) 0xffff;
    data[1733] = (char) 0xffff;
    data[1734] = (char) 0xffff;
    data[1735] = (char) 0xffff;
    data[1736] = (char) 0xffff;
    data[1737] = (char) 0xffff;
    data[1738] = (char) 0xffff;
    data[1739] = (char) 0xffff;
    data[1740] = (char) 0xffff;
    data[1741] = (char) 0xffff;
    data[1742] = (char) 0xffff;
    data[1743] = (char) 0xffff;
    data[1744] = (char) 0xffff;
    data[1745] = (char) 0xffff;
    data[1746] = (char) 0xffff;
    data[1747] = (char) 0xffff;
    data[1748] = (char) 0xffff;
    data[1749] = (char) 0xffff;
    data[1750] = (char) 0xffff;
    data[1751] = (char) 0xffff;
    data[1752] = (char) 0xffff;
    data[1753] = (char) 0xffff;
    data[1754] = (char) 0xffff;
    data[1755] = (char) 0xffff;
    data[1756] = (char) 0xffff;
    data[1757] = (char) 0xffff;
    data[1758] = (char) 0xffff;
    data[1759] = (char) 0xffff;
    data[1760] = (char) 0xffff;
    data[1761] = (char) 0xffff;
    data[1762] = (char) 0xffff;
    data[1763] = (char) 0xffff;
    data[1764] = (char) 0xffff;
    data[1765] = (char) 0xffff;
    data[1766] = (char) 0xffff;
    data[1767] = (char) 0xffff;
    data[1768] = (char) 0xffff;
    data[1769] = (char) 0xffff;
    data[1770] = (char) 0xffff;
    data[1771] = (char) 0xffff;
    data[1772] = (char) 0xffff;
    data[1773] = (char) 0xffff;
    data[1774] = (char) 0xffff;
    data[1775] = (char) 0xffff;
    data[1776] = (char) 0xffff;
    data[1777] = (char) 0xffff;
    data[1778] = (char) 0xffff;
    data[1779] = (char) 0xffff;
    data[1780] = (char) 0xffff;
    data[1781] = (char) 0xffff;
    data[1782] = (char) 0xffff;
    data[1783] = (char) 0xffff;
    data[1784] = (char) 0xffff;
    data[1785] = (char) 0xffff;
    data[1786] = (char) 0xffff;
    data[1787] = (char) 0xffff;
    data[1788] = (char) 0xffff;
    data[1789] = (char) 0xffff;
    data[1790] = (char) 0xffff;
    data[1791] = (char) 0xffff;
    data[1792] = (char) 0xffff;
    data[1793] = (char) 0xffff;
    data[1794] = (char) 0xffff;
    data[1795] = (char) 0xffff;
    data[1796] = (char) 0xffff;
    data[1797] = (char) 0xffff;
    data[1798] = (char) 0xffff;
    data[1799] = (char) 0xffff;
    data[1800] = (char) 0xffff;
    data[1801] = (char) 0xffff;
    data[1802] = (char) 0xffff;
    data[1803] = (char) 0xffff;
    data[1804] = (char) 0xffff;
    data[1805] = (char) 0xffff;
    data[1806] = (char) 0xffff;
    data[1807] = (char) 0xffff;
    data[1808] = (char) 0xffff;
    data[1809] = (char) 0xffff;
    data[1810] = (char) 0xffff;
    data[1811] = (char) 0xffff;
    data[1812] = (char) 0xffff;
    data[1813] = (char) 0xffff;
    data[1814] = (char) 0xffff;
    data[1815] = (char) 0xffff;
    data[1816] = (char) 0xffff;
    data[1817] = (char) 0xffff;
    data[1818] = (char) 0xffff;
    data[1819] = (char) 0xffff;
    data[1820] = (char) 0xffff;
    data[1821] = (char) 0xffff;
    data[1822] = (char) 0xffff;
    data[1823] = (char) 0xffff;
    data[1824] = (char) 0xffff;
    data[1825] = (char) 0xffff;
    data[1826] = (char) 0xffff;
    data[1827] = (char) 0xffff;
    data[1828] = (char) 0xffff;
    data[1829] = (char) 0xffff;
    data[1830] = (char) 0xffff;
    data[1831] = (char) 0xffff;
    data[1832] = (char) 0xffff;
    data[1833] = (char) 0xffff;
    data[1834] = (char) 0xffff;
    data[1835] = (char) 0xffff;
    data[1836] = (char) 0xffff;
    data[1837] = (char) 0xffff;
    data[1838] = (char) 0xffff;
    data[1839] = (char) 0xffff;
    data[1840] = (char) 0xffff;
    data[1841] = (char) 0xffff;
    data[1842] = (char) 0xffff;
    data[1843] = (char) 0xffff;
    data[1844] = (char) 0xffff;
    data[1845] = (char) 0xffff;
    data[1846] = (char) 0xffff;
    data[1847] = (char) 0xffff;
    data[1848] = (char) 0xffff;
    data[1849] = (char) 0xffff;
    data[1850] = (char) 0xffff;
    data[1851] = (char) 0xffff;
    data[1852] = (char) 0xffff;
    data[1853] = (char) 0xffff;
    data[1854] = (char) 0xffff;
    data[1855] = (char) 0xffff;
    data[1856] = (char) 0xffff;
    data[1857] = (char) 0xffff;
    data[1858] = (char) 0xffff;
    data[1859] = (char) 0xffff;
    data[1860] = (char) 0xffff;
    data[1861] = (char) 0xffff;
    data[1862] = (char) 0xffff;
    data[1863] = (char) 0xffff;
    data[1864] = (char) 0xffff;
    data[1865] = (char) 0xffff;
    data[1866] = (char) 0xffff;
    data[1867] = (char) 0xffff;
    data[1868] = (char) 0xffff;
    data[1869] = (char) 0xffff;
    data[1870] = (char) 0xffff;
    data[1871] = (char) 0xffff;
    data[1872] = (char) 0xffff;
    data[1873] = (char) 0xffff;
    data[1874] = (char) 0xffff;
    data[1875] = (char) 0xffff;
    data[1876] = (char) 0xffff;
    data[1877] = (char) 0xffff;
    data[1878] = (char) 0xffff;
    data[1879] = (char) 0xffff;
    data[1880] = (char) 0xffff;
    data[1881] = (char) 0xffff;
    data[1882] = (char) 0xffff;
    data[1883] = (char) 0xffff;
    data[1884] = (char) 0xffff;
    data[1885] = (char) 0xffff;
    data[1886] = (char) 0xffff;
    data[1887] = (char) 0xffff;
    data[1888] = (char) 0xffff;
    data[1889] = (char) 0xffff;
    data[1890] = (char) 0xffff;
    data[1891] = (char) 0xffff;
    data[1892] = (char) 0xffff;
    data[1893] = (char) 0xffff;
    data[1894] = (char) 0xffff;
    data[1895] = (char) 0xffff;
    data[1896] = (char) 0xffff;
    data[1897] = (char) 0xffff;
    data[1898] = (char) 0xffff;
    data[1899] = (char) 0xffff;
    data[1900] = (char) 0xffff;
    data[1901] = (char) 0xffff;
    data[1902] = (char) 0xffff;
    data[1903] = (char) 0xffff;
    data[1904] = (char) 0xffff;
    data[1905] = (char) 0xffff;
    data[1906] = (char) 0xffff;
    data[1907] = (char) 0xffff;
    data[1908] = (char) 0xffff;
    data[1909] = (char) 0xffff;
    data[1910] = (char) 0xffff;
    data[1911] = (char) 0xffff;
    data[1912] = (char) 0xffff;
    data[1913] = (char) 0xffff;
    data[1914] = (char) 0xffff;
    data[1915] = (char) 0xffff;
    data[1916] = (char) 0xffff;
    data[1917] = (char) 0xffff;
    data[1918] = (char) 0xffff;
    data[1919] = (char) 0xffff;
    data[1920] = (char) 0xffff;
    data[1921] = (char) 0xffff;
    data[1922] = (char) 0xffff;
    data[1923] = (char) 0xffff;
    data[1924] = (char) 0xffff;
    data[1925] = (char) 0xffff;
    data[1926] = (char) 0xffff;
    data[1927] = (char) 0xffff;
    data[1928] = (char) 0xffff;
    data[1929] = (char) 0xffff;
    data[1930] = (char) 0xffff;
    data[1931] = (char) 0xffff;
    data[1932] = (char) 0xffff;
    data[1933] = (char) 0xffff;
    data[1934] = (char) 0xffff;
    data[1935] = (char) 0xffff;
    data[1936] = (char) 0xffff;
    data[1937] = (char) 0xffff;
    data[1938] = (char) 0xffff;
    data[1939] = (char) 0xffff;
    data[1940] = (char) 0xffff;
    data[1941] = (char) 0xffff;
    data[1942] = (char) 0xffff;
    data[1943] = (char) 0xffff;
    data[1944] = (char) 0xffff;
    data[1945] = (char) 0xffff;
    data[1946] = (char) 0xffff;
    data[1947] = (char) 0xffff;
    data[1948] = (char) 0xffff;
    data[1949] = (char) 0xffff;
    data[1950] = (char) 0xffff;
    data[1951] = (char) 0xffff;
    data[1952] = (char) 0xffff;
    data[1953] = (char) 0xffff;
    data[1954] = (char) 0xffff;
    data[1955] = (char) 0xffff;
    data[1956] = (char) 0xffff;
    data[1957] = (char) 0xffff;
    data[1958] = (char) 0xffff;
    data[1959] = (char) 0xffff;
    data[1960] = (char) 0xffff;
    data[1961] = (char) 0xffff;
    data[1962] = (char) 0xffff;
    data[1963] = (char) 0xffff;
    data[1964] = (char) 0xffff;
    data[1965] = (char) 0xffff;
    data[1966] = (char) 0xffff;
    data[1967] = (char) 0xffff;
    data[1968] = (char) 0xffff;
    data[1969] = (char) 0xffff;
    data[1970] = (char) 0xffff;
    data[1971] = (char) 0xffff;
    data[1972] = (char) 0xffff;
    data[1973] = (char) 0xffff;
    data[1974] = (char) 0xffff;
    data[1975] = (char) 0xffff;
    data[1976] = (char) 0xffff;
    data[1977] = (char) 0xffff;
    data[1978] = (char) 0xffff;
    data[1979] = (char) 0xffff;
    data[1980] = (char) 0xffff;
    data[1981] = (char) 0xffff;
    data[1982] = (char) 0xffff;
    data[1983] = (char) 0xffff;
    data[1984] = (char) 0xffff;
    data[1985] = (char) 0xffff;
    data[1986] = (char) 0xffff;
    data[1987] = (char) 0xffff;
    data[1988] = (char) 0xffff;
    data[1989] = (char) 0xffff;
    data[1990] = (char) 0xffff;
    data[1991] = (char) 0xffff;
    data[1992] = (char) 0xffff;
    data[1993] = (char) 0xffff;
    data[1994] = (char) 0xffff;
    data[1995] = (char) 0xffff;
    data[1996] = (char) 0xffff;
    data[1997] = (char) 0xffff;
    data[1998] = (char) 0xffff;
    data[1999] = (char) 0xffff;
    data[2000] = (char) 0xffff;
    data[2001] = (char) 0xffff;
    data[2002] = (char) 0xffff;
    data[2003] = (char) 0xffff;
    data[2004] = (char) 0xffff;
    data[2005] = (char) 0xffff;
    data[2006] = (char) 0xffff;
    data[2007] = (char) 0xffff;
    data[2008] = (char) 0xffff;
    data[2009] = (char) 0xffff;
    data[2010] = (char) 0xffff;
    data[2011] = (char) 0xffff;
    data[2012] = (char) 0xffff;
    data[2013] = (char) 0xffff;
    data[2014] = (char) 0xffff;
    data[2015] = (char) 0xffff;
    data[2016] = (char) 0xffff;
    data[2017] = (char) 0xffff;
    data[2018] = (char) 0xffff;
    data[2019] = (char) 0xffff;
    data[2020] = (char) 0xffff;
    data[2021] = (char) 0xffff;
    data[2022] = (char) 0xffff;
    data[2023] = (char) 0xffff;
    data[2024] = (char) 0xffff;
    data[2025] = (char) 0xffff;
    data[2026] = (char) 0xffff;
    data[2027] = (char) 0xffff;
    data[2028] = (char) 0xffff;
    data[2029] = (char) 0xffff;
    data[2030] = (char) 0xffff;
    data[2031] = (char) 0xffff;
    data[2032] = (char) 0xffff;
    data[2033] = (char) 0xffff;
    data[2034] = (char) 0xffff;
    data[2035] = (char) 0xffff;
    data[2036] = (char) 0xffff;
    data[2037] = (char) 0xffff;
    data[2038] = (char) 0xffff;
    data[2039] = (char) 0xffff;
    data[2040] = (char) 0xffff;
    data[2041] = (char) 0xffff;
    data[2042] = (char) 0xffff;
    data[2043] = (char) 0xffff;
    data[2044] = (char) 0xffff;
    data[2045] = (char) 0xffff;
    data[2046] = (char) 0xffff;
    data[2047] = (char) 0xffff;
    data[2048] = (char) 0xffff;
    data[2049] = (char) 0xffff;
    data[2050] = (char) 0xffff;
    data[2051] = (char) 0xffff;
    data[2052] = (char) 0xffff;
    data[2053] = (char) 0xffff;
    data[2054] = (char) 0xffff;
    data[2055] = (char) 0xffff;
    data[2056] = (char) 0xffff;
    data[2057] = (char) 0xffff;
    data[2058] = (char) 0xffff;
    data[2059] = (char) 0xffff;
    data[2060] = (char) 0xffff;
    data[2061] = (char) 0xffff;
    data[2062] = (char) 0xffff;
    data[2063] = (char) 0xffff;
    data[2064] = (char) 0xffff;
    data[2065] = (char) 0xffff;
    data[2066] = (char) 0xffff;
    data[2067] = (char) 0xffff;
    data[2068] = (char) 0xffff;
    data[2069] = (char) 0xffff;
    data[2070] = (char) 0xffff;
    data[2071] = (char) 0xffff;
    data[2072] = (char) 0xffff;
    data[2073] = (char) 0xffff;
    data[2074] = (char) 0xffff;
    data[2075] = (char) 0xffff;
    data[2076] = (char) 0xffff;
    data[2077] = (char) 0xffff;
    data[2078] = (char) 0xffff;
    data[2079] = (char) 0xffff;
    data[2080] = (char) 0xffff;
    data[2081] = (char) 0xffff;
    data[2082] = (char) 0xffff;
    data[2083] = (char) 0xffff;
    data[2084] = (char) 0xffff;
    data[2085] = (char) 0xffff;
    data[2086] = (char) 0xffff;
    data[2087] = (char) 0xffff;
    data[2088] = (char) 0xffff;
    data[2089] = (char) 0xffff;
    data[2090] = (char) 0xffff;
    data[2091] = (char) 0xffff;
    data[2092] = (char) 0xffff;
    data[2093] = (char) 0xffff;
    data[2094] = (char) 0xffff;
    data[2095] = (char) 0xffff;
    data[2096] = (char) 0xffff;
    data[2097] = (char) 0xffff;
    data[2098] = (char) 0xffff;
    data[2099] = (char) 0xffff;
    data[2100] = (char) 0xffff;
    data[2101] = (char) 0xffff;
    data[2102] = (char) 0xffff;
    data[2103] = (char) 0xffff;
    data[2104] = (char) 0xffff;
    data[2105] = (char) 0xffff;
    data[2106] = (char) 0xffff;
    data[2107] = (char) 0xffff;
    data[2108] = (char) 0xffff;
    data[2109] = (char) 0xffff;
    data[2110] = (char) 0xffff;
    data[2111] = (char) 0xffff;
    data[2112] = (char) 0xffff;
    data[2113] = (char) 0xffff;
    data[2114] = (char) 0xffff;
    data[2115] = (char) 0xffff;
    data[2116] = (char) 0xffff;
    data[2117] = (char) 0xffff;
    data[2118] = (char) 0xffff;
    data[2119] = (char) 0xffff;
    data[2120] = (char) 0xffff;
    data[2121] = (char) 0xffff;
    data[2122] = (char) 0xffff;
    data[2123] = (char) 0xffff;
    data[2124] = (char) 0xffff;
    data[2125] = (char) 0xffff;
    data[2126] = (char) 0xffff;
    data[2127] = (char) 0xffff;
    data[2128] = (char) 0xffff;
    data[2129] = (char) 0xffff;
    data[2130] = (char) 0xffff;
    data[2131] = (char) 0xffff;
    data[2132] = (char) 0xffff;
    data[2133] = (char) 0xffff;
    data[2134] = (char) 0xffff;
    data[2135] = (char) 0xffff;
    data[2136] = (char) 0xffff;
    data[2137] = (char) 0xffff;
    data[2138] = (char) 0xffff;
    data[2139] = (char) 0xffff;
    data[2140] = (char) 0xffff;
    data[2141] = (char) 0xffff;
    data[2142] = (char) 0xffff;
    data[2143] = (char) 0xffff;
    data[2144] = (char) 0xffff;
    data[2145] = (char) 0xffff;
    data[2146] = (char) 0xffff;
    data[2147] = (char) 0xffff;
    data[2148] = (char) 0xffff;
    data[2149] = (char) 0xffff;
    data[2150] = (char) 0xffff;
    data[2151] = (char) 0xffff;
    data[2152] = (char) 0xffff;
    data[2153] = (char) 0xffff;
    data[2154] = (char) 0xffff;
    data[2155] = (char) 0xffff;
    data[2156] = (char) 0xffff;
    data[2157] = (char) 0xffff;
    data[2158] = (char) 0xffff;
    data[2159] = (char) 0xffff;
    data[2160] = (char) 0xffff;
    data[2161] = (char) 0xffff;
    data[2162] = (char) 0xffff;
    data[2163] = (char) 0xffff;
    data[2164] = (char) 0xffff;
    data[2165] = (char) 0xffff;
    data[2166] = (char) 0xffff;
    data[2167] = (char) 0xffff;
    data[2168] = (char) 0xffff;
    data[2169] = (char) 0xffff;
    data[2170] = (char) 0xffff;
    data[2171] = (char) 0xffff;
    data[2172] = (char) 0xffff;
    data[2173] = (char) 0xffff;
    data[2174] = (char) 0xffff;
    data[2175] = (char) 0xffff;
    data[2176] = (char) 0xffff;
    data[2177] = (char) 0xffff;
    data[2178] = (char) 0xffff;
    data[2179] = (char) 0xffff;
    data[2180] = (char) 0xffff;
    data[2181] = (char) 0xffff;
    data[2182] = (char) 0xffff;
    data[2183] = (char) 0xffff;
    data[2184] = (char) 0xffff;
    data[2185] = (char) 0xffff;
    data[2186] = (char) 0xffff;
    data[2187] = (char) 0xffff;
    data[2188] = (char) 0xffff;
    data[2189] = (char) 0xffff;
    data[2190] = (char) 0xffff;
    data[2191] = (char) 0xffff;
    data[2192] = (char) 0xffff;
    data[2193] = (char) 0xffff;
    data[2194] = (char) 0xffff;
    data[2195] = (char) 0xffff;
    data[2196] = (char) 0xffff;
    data[2197] = (char) 0xffff;
    data[2198] = (char) 0xffff;
    data[2199] = (char) 0xffff;
    data[2200] = (char) 0xffff;
    data[2201] = (char) 0xffff;
    data[2202] = (char) 0xffff;
    data[2203] = (char) 0xffff;
    data[2204] = (char) 0xffff;
    data[2205] = (char) 0xffff;
    data[2206] = (char) 0xffff;
    data[2207] = (char) 0xffff;
    data[2208] = (char) 0xffff;
    data[2209] = (char) 0xffff;
    data[2210] = (char) 0xffff;
    data[2211] = (char) 0xffff;
    data[2212] = (char) 0xffff;
    data[2213] = (char) 0xffff;
    data[2214] = (char) 0xffff;
    data[2215] = (char) 0xffff;
    data[2216] = (char) 0xffff;
    data[2217] = (char) 0xffff;
    data[2218] = (char) 0xffff;
    data[2219] = (char) 0xffff;
    data[2220] = (char) 0xffff;
    data[2221] = (char) 0xffff;
    data[2222] = (char) 0xffff;
    data[2223] = (char) 0xffff;
    data[2224] = (char) 0xffff;
    data[2225] = (char) 0xffff;
    data[2226] = (char) 0xffff;
    data[2227] = (char) 0xffff;
    data[2228] = (char) 0xffff;
    data[2229] = (char) 0xffff;
    data[2230] = (char) 0xffff;
    data[2231] = (char) 0xffff;
    data[2232] = (char) 0xffff;
    data[2233] = (char) 0xffff;
    data[2234] = (char) 0xffff;
    data[2235] = (char) 0xffff;
    data[2236] = (char) 0xffff;
    data[2237] = (char) 0xffff;
    data[2238] = (char) 0xffff;
    data[2239] = (char) 0xffff;
    data[2240] = (char) 0xffff;
    data[2241] = (char) 0xffff;
    data[2242] = (char) 0xffff;
    data[2243] = (char) 0xffff;
    data[2244] = (char) 0xffff;
    data[2245] = (char) 0xffff;
    data[2246] = (char) 0xffff;
    data[2247] = (char) 0xffff;
    data[2248] = (char) 0xffff;
    data[2249] = (char) 0xffff;
    data[2250] = (char) 0xffff;
    data[2251] = (char) 0xffff;
    data[2252] = (char) 0xffff;
    data[2253] = (char) 0xffff;
    data[2254] = (char) 0xffff;
    data[2255] = (char) 0xffff;
    data[2256] = (char) 0xffff;
    data[2257] = (char) 0xffff;
    data[2258] = (char) 0xffff;
    data[2259] = (char) 0xffff;
    data[2260] = (char) 0xffff;
    data[2261] = (char) 0xffff;
    data[2262] = (char) 0xffff;
    data[2263] = (char) 0xffff;
    data[2264] = (char) 0xffff;
    data[2265] = (char) 0xffff;
    data[2266] = (char) 0xffff;
    data[2267] = (char) 0xffff;
    data[2268] = (char) 0xffff;
    data[2269] = (char) 0xffff;
    data[2270] = (char) 0xffff;
    data[2271] = (char) 0xffff;
    data[2272] = (char) 0xffff;
    data[2273] = (char) 0xffff;
    data[2274] = (char) 0xffff;
    data[2275] = (char) 0xffff;
    data[2276] = (char) 0xffff;
    data[2277] = (char) 0xffff;
    data[2278] = (char) 0xffff;
    data[2279] = (char) 0xffff;
    data[2280] = (char) 0xffff;
    data[2281] = (char) 0xffff;
    data[2282] = (char) 0xffff;
    data[2283] = (char) 0xffff;
    data[2284] = (char) 0xffff;
    data[2285] = (char) 0xffff;
    data[2286] = (char) 0xffff;
    data[2287] = (char) 0xffff;
    data[2288] = (char) 0xffff;
    data[2289] = (char) 0xffff;
    data[2290] = (char) 0xffff;
    data[2291] = (char) 0xffff;
    data[2292] = (char) 0xffff;
    data[2293] = (char) 0xffff;
    data[2294] = (char) 0xffff;
    data[2295] = (char) 0xffff;
    data[2296] = (char) 0xffff;
    data[2297] = (char) 0xffff;
    data[2298] = (char) 0xffff;
    data[2299] = (char) 0xffff;
    data[2300] = (char) 0xffff;
    data[2301] = (char) 0xffff;
    data[2302] = (char) 0xffff;
    data[2303] = (char) 0xffff;
    data[2304] = (char) 0xffff;
    data[2305] = (char) 0xffff;
    data[2306] = (char) 0xffff;
    data[2307] = (char) 0xffff;
    data[2308] = (char) 0xffff;
    data[2309] = (char) 0xffff;
    data[2310] = (char) 0xffff;
    data[2311] = (char) 0xffff;
    data[2312] = (char) 0xffff;
    data[2313] = (char) 0xffff;
    data[2314] = (char) 0xffff;
    data[2315] = (char) 0xffff;
    data[2316] = (char) 0xffff;
    data[2317] = (char) 0xffff;
    data[2318] = (char) 0xffff;
    data[2319] = (char) 0xffff;
    data[2320] = (char) 0xffff;
    data[2321] = (char) 0xffff;
    data[2322] = (char) 0xffff;
    data[2323] = (char) 0xffff;
    data[2324] = (char) 0xffff;
    data[2325] = (char) 0xffff;
    data[2326] = (char) 0xffff;
    data[2327] = (char) 0xffff;
    data[2328] = (char) 0xffff;
    data[2329] = (char) 0xffff;
    data[2330] = (char) 0xffff;
    data[2331] = (char) 0xffff;
    data[2332] = (char) 0xffff;
    data[2333] = (char) 0xffff;
    data[2334] = (char) 0xffff;
    data[2335] = (char) 0xffff;
    data[2336] = (char) 0xffff;
    data[2337] = (char) 0xffff;
    data[2338] = (char) 0xffff;
    data[2339] = (char) 0xffff;
    data[2340] = (char) 0xffff;
    data[2341] = (char) 0xffff;
    data[2342] = (char) 0xffff;
    data[2343] = (char) 0xffff;
    data[2344] = (char) 0xffff;
    data[2345] = (char) 0xffff;
    data[2346] = (char) 0xffff;
    data[2347] = (char) 0xffff;
    data[2348] = (char) 0xffff;
    data[2349] = (char) 0xffff;
    data[2350] = (char) 0xffff;
    data[2351] = (char) 0xffff;
    data[2352] = (char) 0xffff;
    data[2353] = (char) 0xffff;
    data[2354] = (char) 0xffff;
    data[2355] = (char) 0xffff;
    data[2356] = (char) 0xffff;
    data[2357] = (char) 0xffff;
    data[2358] = (char) 0xffff;
    data[2359] = (char) 0xffff;
    data[2360] = (char) 0xffff;
    data[2361] = (char) 0xffff;
    data[2362] = (char) 0xffff;
    data[2363] = (char) 0xffff;
    data[2364] = (char) 0xffff;
    data[2365] = (char) 0xffff;
    data[2366] = (char) 0xffff;
    data[2367] = (char) 0xffff;
    data[2368] = (char) 0xffff;
    data[2369] = (char) 0xffff;
    data[2370] = (char) 0xffff;
    data[2371] = (char) 0xffff;
    data[2372] = (char) 0xffff;
    data[2373] = (char) 0xffff;
    data[2374] = (char) 0xffff;
    data[2375] = (char) 0xffff;
    data[2376] = (char) 0xffff;
    data[2377] = (char) 0xffff;
    data[2378] = (char) 0xffff;
    data[2379] = (char) 0xffff;
    data[2380] = (char) 0xffff;
    data[2381] = (char) 0xffff;
    data[2382] = (char) 0xffff;
    data[2383] = (char) 0xffff;
    data[2384] = (char) 0xffff;
    data[2385] = (char) 0xffff;
    data[2386] = (char) 0xffff;
    data[2387] = (char) 0xffff;
    data[2388] = (char) 0xffff;
    data[2389] = (char) 0xffff;
    data[2390] = (char) 0xffff;
    data[2391] = (char) 0xffff;
    data[2392] = (char) 0xffff;
    data[2393] = (char) 0xffff;
    data[2394] = (char) 0xffff;
    data[2395] = (char) 0xffff;
    data[2396] = (char) 0xffff;
    data[2397] = (char) 0xffff;
    data[2398] = (char) 0xffff;
    data[2399] = (char) 0xffff;
    data[2400] = (char) 0xffff;
    data[2401] = (char) 0xffff;
    data[2402] = (char) 0xffff;
    data[2403] = (char) 0xffff;
    data[2404] = (char) 0xffff;
    data[2405] = (char) 0xffff;
    data[2406] = (char) 0xffff;
    data[2407] = (char) 0xffff;
    data[2408] = (char) 0xffff;
    data[2409] = (char) 0xffff;
    data[2410] = (char) 0xffff;
    data[2411] = (char) 0xffff;
    data[2412] = (char) 0xffff;
    data[2413] = (char) 0xffff;
    data[2414] = (char) 0xffff;
    data[2415] = (char) 0xffff;
    data[2416] = (char) 0xffff;
    data[2417] = (char) 0xffff;
    data[2418] = (char) 0xffff;
    data[2419] = (char) 0xffff;
    data[2420] = (char) 0xffff;
    data[2421] = (char) 0xffff;
    data[2422] = (char) 0xffff;
    data[2423] = (char) 0xffff;
    data[2424] = (char) 0xffff;
    data[2425] = (char) 0xffff;
    data[2426] = (char) 0xffff;
    data[2427] = (char) 0xffff;
    data[2428] = (char) 0xffff;
    data[2429] = (char) 0xffff;
    data[2430] = (char) 0xffff;
    data[2431] = (char) 0xffff;
    data[2432] = (char) 0xffff;
    data[2433] = (char) 0xffff;
    data[2434] = (char) 0xffff;
    data[2435] = (char) 0xffff;
    data[2436] = (char) 0xffff;
    data[2437] = (char) 0xffff;
    data[2438] = (char) 0xffff;
    data[2439] = (char) 0xffff;
    data[2440] = (char) 0xffff;
    data[2441] = (char) 0xffff;
    data[2442] = (char) 0xffff;
    data[2443] = (char) 0xffff;
    data[2444] = (char) 0xffff;
    data[2445] = (char) 0xffff;
    data[2446] = (char) 0xffff;
    data[2447] = (char) 0xffff;
    data[2448] = (char) 0xffff;
    data[2449] = (char) 0xffff;
    data[2450] = (char) 0xffff;
    data[2451] = (char) 0xffff;
    data[2452] = (char) 0xffff;
    data[2453] = (char) 0xffff;
    data[2454] = (char) 0xffff;
    data[2455] = (char) 0xffff;
    data[2456] = (char) 0xffff;
    data[2457] = (char) 0xffff;
    data[2458] = (char) 0xffff;
    data[2459] = (char) 0xffff;
    data[2460] = (char) 0xffff;
    data[2461] = (char) 0xffff;
    data[2462] = (char) 0xffff;
    data[2463] = (char) 0xffff;
    data[2464] = (char) 0xffff;
    data[2465] = (char) 0xffff;
    data[2466] = (char) 0xffff;
    data[2467] = (char) 0xffff;
    data[2468] = (char) 0xffff;
    data[2469] = (char) 0xffff;
    data[2470] = (char) 0xffff;
    data[2471] = (char) 0xffff;
    data[2472] = (char) 0xffff;
    data[2473] = (char) 0xffff;
    data[2474] = (char) 0xffff;
    data[2475] = (char) 0xffff;
    data[2476] = (char) 0xffff;
    data[2477] = (char) 0xffff;
    data[2478] = (char) 0xffff;
    data[2479] = (char) 0xffff;
    data[2480] = (char) 0xffff;
    data[2481] = (char) 0xffff;
    data[2482] = (char) 0xffff;
    data[2483] = (char) 0xffff;
    data[2484] = (char) 0xffff;
    data[2485] = (char) 0xffff;
    data[2486] = (char) 0xffff;
    data[2487] = (char) 0xffff;
    data[2488] = (char) 0xffff;
    data[2489] = (char) 0xffff;
    data[2490] = (char) 0xffff;
    data[2491] = (char) 0xffff;
    data[2492] = (char) 0xffff;
    data[2493] = (char) 0xffff;
    data[2494] = (char) 0xffff;
    data[2495] = (char) 0xffff;
    data[2496] = (char) 0xffff;
    data[2497] = (char) 0xffff;
    data[2498] = (char) 0xffff;
    data[2499] = (char) 0xffff;
    data[2500] = (char) 0xffff;
    data[2501] = (char) 0xffff;
    data[2502] = (char) 0xffff;
    data[2503] = (char) 0xffff;
    data[2504] = (char) 0xffff;
    data[2505] = (char) 0xffff;
    data[2506] = (char) 0xffff;
    data[2507] = (char) 0xffff;
    data[2508] = (char) 0xffff;
    data[2509] = (char) 0xffff;
    data[2510] = (char) 0xffff;
    data[2511] = (char) 0xffff;
    data[2512] = (char) 0xffff;
    data[2513] = (char) 0xffff;
    data[2514] = (char) 0xffff;
    data[2515] = (char) 0xffff;
    data[2516] = (char) 0xffff;
    data[2517] = (char) 0xffff;
    data[2518] = (char) 0xffff;
    data[2519] = (char) 0xffff;
    data[2520] = (char) 0xffff;
    data[2521] = (char) 0xffff;
    data[2522] = (char) 0xffff;
    data[2523] = (char) 0xffff;
    data[2524] = (char) 0xffff;
    data[2525] = (char) 0xffff;
    data[2526] = (char) 0xffff;
    data[2527] = (char) 0xffff;
    data[2528] = (char) 0xffff;
    data[2529] = (char) 0xffff;
    data[2530] = (char) 0xffff;
    data[2531] = (char) 0xffff;
    data[2532] = (char) 0xffff;
    data[2533] = (char) 0xffff;
    data[2534] = (char) 0xffff;
    data[2535] = (char) 0xffff;
    data[2536] = (char) 0xffff;
    data[2537] = (char) 0xffff;
    data[2538] = (char) 0xffff;
    data[2539] = (char) 0xffff;
    data[2540] = (char) 0xffff;
    data[2541] = (char) 0xffff;
    data[2542] = (char) 0xffff;
    data[2543] = (char) 0xffff;
    data[2544] = (char) 0xffff;
    data[2545] = (char) 0xffff;
    data[2546] = (char) 0xffff;
    data[2547] = (char) 0xffff;
    data[2548] = (char) 0xffff;
    data[2549] = (char) 0xffff;
    data[2550] = (char) 0xffff;
    data[2551] = (char) 0xffff;
    data[2552] = (char) 0xffff;
    data[2553] = (char) 0xffff;
    data[2554] = (char) 0x003f;
    data[2752] = (char) 0xffff;
    data[2753] = (char) 0xffff;
    data[2754] = (char) 0xffff;
    data[2755] = (char) 0xffff;
    data[2756] = (char) 0xffff;
    data[2757] = (char) 0xffff;
    data[2758] = (char) 0xffff;
    data[2759] = (char) 0xffff;
    data[2760] = (char) 0xffff;
    data[2761] = (char) 0xffff;
    data[2762] = (char) 0xffff;
    data[2763] = (char) 0xffff;
    data[2764] = (char) 0xffff;
    data[2765] = (char) 0xffff;
    data[2766] = (char) 0xffff;
    data[2767] = (char) 0xffff;
    data[2768] = (char) 0xffff;
    data[2769] = (char) 0xffff;
    data[2770] = (char) 0xffff;
    data[2771] = (char) 0xffff;
    data[2772] = (char) 0xffff;
    data[2773] = (char) 0xffff;
    data[2774] = (char) 0xffff;
    data[2775] = (char) 0xffff;
    data[2776] = (char) 0xffff;
    data[2777] = (char) 0xffff;
    data[2778] = (char) 0xffff;
    data[2779] = (char) 0xffff;
    data[2780] = (char) 0xffff;
    data[2781] = (char) 0xffff;
    data[2782] = (char) 0xffff;
    data[2783] = (char) 0xffff;
    data[2784] = (char) 0xffff;
    data[2785] = (char) 0xffff;
    data[2786] = (char) 0xffff;
    data[2787] = (char) 0xffff;
    data[2788] = (char) 0xffff;
    data[2789] = (char) 0xffff;
    data[2790] = (char) 0xffff;
    data[2791] = (char) 0xffff;
    data[2792] = (char) 0xffff;
    data[2793] = (char) 0xffff;
    data[2794] = (char) 0xffff;
    data[2795] = (char) 0xffff;
    data[2796] = (char) 0xffff;
    data[2797] = (char) 0xffff;
    data[2798] = (char) 0xffff;
    data[2799] = (char) 0xffff;
    data[2800] = (char) 0xffff;
    data[2801] = (char) 0xffff;
    data[2802] = (char) 0xffff;
    data[2803] = (char) 0xffff;
    data[2804] = (char) 0xffff;
    data[2805] = (char) 0xffff;
    data[2806] = (char) 0xffff;
    data[2807] = (char) 0xffff;
    data[2808] = (char) 0xffff;
    data[2809] = (char) 0xffff;
    data[2810] = (char) 0xffff;
    data[2811] = (char) 0xffff;
    data[2812] = (char) 0xffff;
    data[2813] = (char) 0xffff;
    data[2814] = (char) 0xffff;
    data[2815] = (char) 0xffff;
    data[2816] = (char) 0xffff;
    data[2817] = (char) 0xffff;
    data[2818] = (char) 0xffff;
    data[2819] = (char) 0xffff;
    data[2820] = (char) 0xffff;
    data[2821] = (char) 0xffff;
    data[2822] = (char) 0xffff;
    data[2823] = (char) 0xffff;
    data[2824] = (char) 0xffff;
    data[2825] = (char) 0xffff;
    data[2826] = (char) 0xffff;
    data[2827] = (char) 0xffff;
    data[2828] = (char) 0xffff;
    data[2829] = (char) 0xffff;
    data[2830] = (char) 0xffff;
    data[2831] = (char) 0xffff;
    data[2832] = (char) 0xffff;
    data[2833] = (char) 0xffff;
    data[2834] = (char) 0xffff;
    data[2835] = (char) 0xffff;
    data[2836] = (char) 0xffff;
    data[2837] = (char) 0xffff;
    data[2838] = (char) 0xffff;
    data[2839] = (char) 0xffff;
    data[2840] = (char) 0xffff;
    data[2841] = (char) 0xffff;
    data[2842] = (char) 0xffff;
    data[2843] = (char) 0xffff;
    data[2844] = (char) 0xffff;
    data[2845] = (char) 0xffff;
    data[2846] = (char) 0xffff;
    data[2847] = (char) 0xffff;
    data[2848] = (char) 0xffff;
    data[2849] = (char) 0xffff;
    data[2850] = (char) 0xffff;
    data[2851] = (char) 0xffff;
    data[2852] = (char) 0xffff;
    data[2853] = (char) 0xffff;
    data[2854] = (char) 0xffff;
    data[2855] = (char) 0xffff;
    data[2856] = (char) 0xffff;
    data[2857] = (char) 0xffff;
    data[2858] = (char) 0xffff;
    data[2859] = (char) 0xffff;
    data[2860] = (char) 0xffff;
    data[2861] = (char) 0xffff;
    data[2862] = (char) 0xffff;
    data[2863] = (char) 0xffff;
    data[2864] = (char) 0xffff;
    data[2865] = (char) 0xffff;
    data[2866] = (char) 0xffff;
    data[2867] = (char) 0xffff;
    data[2868] = (char) 0xffff;
    data[2869] = (char) 0xffff;
    data[2870] = (char) 0xffff;
    data[2871] = (char) 0xffff;
    data[2872] = (char) 0xffff;
    data[2873] = (char) 0xffff;
    data[2874] = (char) 0xffff;
    data[2875] = (char) 0xffff;
    data[2876] = (char) 0xffff;
    data[2877] = (char) 0xffff;
    data[2878] = (char) 0xffff;
    data[2879] = (char) 0xffff;
    data[2880] = (char) 0xffff;
    data[2881] = (char) 0xffff;
    data[2882] = (char) 0xffff;
    data[2883] = (char) 0xffff;
    data[2884] = (char) 0xffff;
    data[2885] = (char) 0xffff;
    data[2886] = (char) 0xffff;
    data[2887] = (char) 0xffff;
    data[2888] = (char) 0xffff;
    data[2889] = (char) 0xffff;
    data[2890] = (char) 0xffff;
    data[2891] = (char) 0xffff;
    data[2892] = (char) 0xffff;
    data[2893] = (char) 0xffff;
    data[2894] = (char) 0xffff;
    data[2895] = (char) 0xffff;
    data[2896] = (char) 0xffff;
    data[2897] = (char) 0xffff;
    data[2898] = (char) 0xffff;
    data[2899] = (char) 0xffff;
    data[2900] = (char) 0xffff;
    data[2901] = (char) 0xffff;
    data[2902] = (char) 0xffff;
    data[2903] = (char) 0xffff;
    data[2904] = (char) 0xffff;
    data[2905] = (char) 0xffff;
    data[2906] = (char) 0xffff;
    data[2907] = (char) 0xffff;
    data[2908] = (char) 0xffff;
    data[2909] = (char) 0xffff;
    data[2910] = (char) 0xffff;
    data[2911] = (char) 0xffff;
    data[2912] = (char) 0xffff;
    data[2913] = (char) 0xffff;
    data[2914] = (char) 0xffff;
    data[2915] = (char) 0xffff;
    data[2916] = (char) 0xffff;
    data[2917] = (char) 0xffff;
    data[2918] = (char) 0xffff;
    data[2919] = (char) 0xffff;
    data[2920] = (char) 0xffff;
    data[2921] = (char) 0xffff;
    data[2922] = (char) 0xffff;
    data[2923] = (char) 0xffff;
    data[2924] = (char) 0xffff;
    data[2925] = (char) 0xffff;
    data[2926] = (char) 0xffff;
    data[2927] = (char) 0xffff;
    data[2928] = (char) 0xffff;
    data[2929] = (char) 0xffff;
    data[2930] = (char) 0xffff;
    data[2931] = (char) 0xffff;
    data[2932] = (char) 0xffff;
    data[2933] = (char) 0xffff;
    data[2934] = (char) 0xffff;
    data[2935] = (char) 0xffff;
    data[2936] = (char) 0xffff;
    data[2937] = (char) 0xffff;
    data[2938] = (char) 0xffff;
    data[2939] = (char) 0xffff;
    data[2940] = (char) 0xffff;
    data[2941] = (char) 0xffff;
    data[2942] = (char) 0xffff;
    data[2943] = (char) 0xffff;
    data[2944] = (char) 0xffff;
    data[2945] = (char) 0xffff;
    data[2946] = (char) 0xffff;
    data[2947] = (char) 0xffff;
    data[2948] = (char) 0xffff;
    data[2949] = (char) 0xffff;
    data[2950] = (char) 0xffff;
    data[2951] = (char) 0xffff;
    data[2952] = (char) 0xffff;
    data[2953] = (char) 0xffff;
    data[2954] = (char) 0xffff;
    data[2955] = (char) 0xffff;
    data[2956] = (char) 0xffff;
    data[2957] = (char) 0xffff;
    data[2958] = (char) 0xffff;
    data[2959] = (char) 0xffff;
    data[2960] = (char) 0xffff;
    data[2961] = (char) 0xffff;
    data[2962] = (char) 0xffff;
    data[2963] = (char) 0xffff;
    data[2964] = (char) 0xffff;
    data[2965] = (char) 0xffff;
    data[2966] = (char) 0xffff;
    data[2967] = (char) 0xffff;
    data[2968] = (char) 0xffff;
    data[2969] = (char) 0xffff;
    data[2970] = (char) 0xffff;
    data[2971] = (char) 0xffff;
    data[2972] = (char) 0xffff;
    data[2973] = (char) 0xffff;
    data[2974] = (char) 0xffff;
    data[2975] = (char) 0xffff;
    data[2976] = (char) 0xffff;
    data[2977] = (char) 0xffff;
    data[2978] = (char) 0xffff;
    data[2979] = (char) 0xffff;
    data[2980] = (char) 0xffff;
    data[2981] = (char) 0xffff;
    data[2982] = (char) 0xffff;
    data[2983] = (char) 0xffff;
    data[2984] = (char) 0xffff;
    data[2985] = (char) 0xffff;
    data[2986] = (char) 0xffff;
    data[2987] = (char) 0xffff;
    data[2988] = (char) 0xffff;
    data[2989] = (char) 0xffff;
    data[2990] = (char) 0xffff;
    data[2991] = (char) 0xffff;
    data[2992] = (char) 0xffff;
    data[2993] = (char) 0xffff;
    data[2994] = (char) 0xffff;
    data[2995] = (char) 0xffff;
    data[2996] = (char) 0xffff;
    data[2997] = (char) 0xffff;
    data[2998] = (char) 0xffff;
    data[2999] = (char) 0xffff;
    data[3000] = (char) 0xffff;
    data[3001] = (char) 0xffff;
    data[3002] = (char) 0xffff;
    data[3003] = (char) 0xffff;
    data[3004] = (char) 0xffff;
    data[3005] = (char) 0xffff;
    data[3006] = (char) 0xffff;
    data[3007] = (char) 0xffff;
    data[3008] = (char) 0xffff;
    data[3009] = (char) 0xffff;
    data[3010] = (char) 0xffff;
    data[3011] = (char) 0xffff;
    data[3012] = (char) 0xffff;
    data[3013] = (char) 0xffff;
    data[3014] = (char) 0xffff;
    data[3015] = (char) 0xffff;
    data[3016] = (char) 0xffff;
    data[3017] = (char) 0xffff;
    data[3018] = (char) 0xffff;
    data[3019] = (char) 0xffff;
    data[3020] = (char) 0xffff;
    data[3021] = (char) 0xffff;
    data[3022] = (char) 0xffff;
    data[3023] = (char) 0xffff;
    data[3024] = (char) 0xffff;
    data[3025] = (char) 0xffff;
    data[3026] = (char) 0xffff;
    data[3027] = (char) 0xffff;
    data[3028] = (char) 0xffff;
    data[3029] = (char) 0xffff;
    data[3030] = (char) 0xffff;
    data[3031] = (char) 0xffff;
    data[3032] = (char) 0xffff;
    data[3033] = (char) 0xffff;
    data[3034] = (char) 0xffff;
    data[3035] = (char) 0xffff;
    data[3036] = (char) 0xffff;
    data[3037] = (char) 0xffff;
    data[3038] = (char) 0xffff;
    data[3039] = (char) 0xffff;
    data[3040] = (char) 0xffff;
    data[3041] = (char) 0xffff;
    data[3042] = (char) 0xffff;
    data[3043] = (char) 0xffff;
    data[3044] = (char) 0xffff;
    data[3045] = (char) 0xffff;
    data[3046] = (char) 0xffff;
    data[3047] = (char) 0xffff;
    data[3048] = (char) 0xffff;
    data[3049] = (char) 0xffff;
    data[3050] = (char) 0xffff;
    data[3051] = (char) 0xffff;
    data[3052] = (char) 0xffff;
    data[3053] = (char) 0xffff;
    data[3054] = (char) 0xffff;
    data[3055] = (char) 0xffff;
    data[3056] = (char) 0xffff;
    data[3057] = (char) 0xffff;
    data[3058] = (char) 0xffff;
    data[3059] = (char) 0xffff;
    data[3060] = (char) 0xffff;
    data[3061] = (char) 0xffff;
    data[3062] = (char) 0xffff;
    data[3063] = (char) 0xffff;
    data[3064] = (char) 0xffff;
    data[3065] = (char) 0xffff;
    data[3066] = (char) 0xffff;
    data[3067] = (char) 0xffff;
    data[3068] = (char) 0xffff;
    data[3069] = (char) 0xffff;
    data[3070] = (char) 0xffff;
    data[3071] = (char) 0xffff;
    data[3072] = (char) 0xffff;
    data[3073] = (char) 0xffff;
    data[3074] = (char) 0xffff;
    data[3075] = (char) 0xffff;
    data[3076] = (char) 0xffff;
    data[3077] = (char) 0xffff;
    data[3078] = (char) 0xffff;
    data[3079] = (char) 0xffff;
    data[3080] = (char) 0xffff;
    data[3081] = (char) 0xffff;
    data[3082] = (char) 0xffff;
    data[3083] = (char) 0xffff;
    data[3084] = (char) 0xffff;
    data[3085] = (char) 0xffff;
    data[3086] = (char) 0xffff;
    data[3087] = (char) 0xffff;
    data[3088] = (char) 0xffff;
    data[3089] = (char) 0xffff;
    data[3090] = (char) 0xffff;
    data[3091] = (char) 0xffff;
    data[3092] = (char) 0xffff;
    data[3093] = (char) 0xffff;
    data[3094] = (char) 0xffff;
    data[3095] = (char) 0xffff;
    data[3096] = (char) 0xffff;
    data[3097] = (char) 0xffff;
    data[3098] = (char) 0xffff;
    data[3099] = (char) 0xffff;
    data[3100] = (char) 0xffff;
    data[3101] = (char) 0xffff;
    data[3102] = (char) 0xffff;
    data[3103] = (char) 0xffff;
    data[3104] = (char) 0xffff;
    data[3105] = (char) 0xffff;
    data[3106] = (char) 0xffff;
    data[3107] = (char) 0xffff;
    data[3108] = (char) 0xffff;
    data[3109] = (char) 0xffff;
    data[3110] = (char) 0xffff;
    data[3111] = (char) 0xffff;
    data[3112] = (char) 0xffff;
    data[3113] = (char) 0xffff;
    data[3114] = (char) 0xffff;
    data[3115] = (char) 0xffff;
    data[3116] = (char) 0xffff;
    data[3117] = (char) 0xffff;
    data[3118] = (char) 0xffff;
    data[3119] = (char) 0xffff;
    data[3120] = (char) 0xffff;
    data[3121] = (char) 0xffff;
    data[3122] = (char) 0xffff;
    data[3123] = (char) 0xffff;
    data[3124] = (char) 0xffff;
    data[3125] = (char) 0xffff;
    data[3126] = (char) 0xffff;
    data[3127] = (char) 0xffff;
    data[3128] = (char) 0xffff;
    data[3129] = (char) 0xffff;
    data[3130] = (char) 0xffff;
    data[3131] = (char) 0xffff;
    data[3132] = (char) 0xffff;
    data[3133] = (char) 0xffff;
    data[3134] = (char) 0xffff;
    data[3135] = (char) 0xffff;
    data[3136] = (char) 0xffff;
    data[3137] = (char) 0xffff;
    data[3138] = (char) 0xffff;
    data[3139] = (char) 0xffff;
    data[3140] = (char) 0xffff;
    data[3141] = (char) 0xffff;
    data[3142] = (char) 0xffff;
    data[3143] = (char) 0xffff;
    data[3144] = (char) 0xffff;
    data[3145] = (char) 0xffff;
    data[3146] = (char) 0xffff;
    data[3147] = (char) 0xffff;
    data[3148] = (char) 0xffff;
    data[3149] = (char) 0xffff;
    data[3150] = (char) 0xffff;
    data[3151] = (char) 0xffff;
    data[3152] = (char) 0xffff;
    data[3153] = (char) 0xffff;
    data[3154] = (char) 0xffff;
    data[3155] = (char) 0xffff;
    data[3156] = (char) 0xffff;
    data[3157] = (char) 0xffff;
    data[3158] = (char) 0xffff;
    data[3159] = (char) 0xffff;
    data[3160] = (char) 0xffff;
    data[3161] = (char) 0xffff;
    data[3162] = (char) 0xffff;
    data[3163] = (char) 0xffff;
    data[3164] = (char) 0xffff;
    data[3165] = (char) 0xffff;
    data[3166] = (char) 0xffff;
    data[3167] = (char) 0xffff;
    data[3168] = (char) 0xffff;
    data[3169] = (char) 0xffff;
    data[3170] = (char) 0xffff;
    data[3171] = (char) 0xffff;
    data[3172] = (char) 0xffff;
    data[3173] = (char) 0xffff;
    data[3174] = (char) 0xffff;
    data[3175] = (char) 0xffff;
    data[3176] = (char) 0xffff;
    data[3177] = (char) 0xffff;
    data[3178] = (char) 0xffff;
    data[3179] = (char) 0xffff;
    data[3180] = (char) 0xffff;
    data[3181] = (char) 0xffff;
    data[3182] = (char) 0xffff;
    data[3183] = (char) 0xffff;
    data[3184] = (char) 0xffff;
    data[3185] = (char) 0xffff;
    data[3186] = (char) 0xffff;
    data[3187] = (char) 0xffff;
    data[3188] = (char) 0xffff;
    data[3189] = (char) 0xffff;
    data[3190] = (char) 0xffff;
    data[3191] = (char) 0xffff;
    data[3192] = (char) 0xffff;
    data[3193] = (char) 0xffff;
    data[3194] = (char) 0xffff;
    data[3195] = (char) 0xffff;
    data[3196] = (char) 0xffff;
    data[3197] = (char) 0xffff;
    data[3198] = (char) 0xffff;
    data[3199] = (char) 0xffff;
    data[3200] = (char) 0xffff;
    data[3201] = (char) 0xffff;
    data[3202] = (char) 0xffff;
    data[3203] = (char) 0xffff;
    data[3204] = (char) 0xffff;
    data[3205] = (char) 0xffff;
    data[3206] = (char) 0xffff;
    data[3207] = (char) 0xffff;
    data[3208] = (char) 0xffff;
    data[3209] = (char) 0xffff;
    data[3210] = (char) 0xffff;
    data[3211] = (char) 0xffff;
    data[3212] = (char) 0xffff;
    data[3213] = (char) 0xffff;
    data[3214] = (char) 0xffff;
    data[3215] = (char) 0xffff;
    data[3216] = (char) 0xffff;
    data[3217] = (char) 0xffff;
    data[3218] = (char) 0xffff;
    data[3219] = (char) 0xffff;
    data[3220] = (char) 0xffff;
    data[3221] = (char) 0xffff;
    data[3222] = (char) 0xffff;
    data[3223] = (char) 0xffff;
    data[3224] = (char) 0xffff;
    data[3225] = (char) 0xffff;
    data[3226] = (char) 0xffff;
    data[3227] = (char) 0xffff;
    data[3228] = (char) 0xffff;
    data[3229] = (char) 0xffff;
    data[3230] = (char) 0xffff;
    data[3231] = (char) 0xffff;
    data[3232] = (char) 0xffff;
    data[3233] = (char) 0xffff;
    data[3234] = (char) 0xffff;
    data[3235] = (char) 0xffff;
    data[3236] = (char) 0xffff;
    data[3237] = (char) 0xffff;
    data[3238] = (char) 0xffff;
    data[3239] = (char) 0xffff;
    data[3240] = (char) 0xffff;
    data[3241] = (char) 0xffff;
    data[3242] = (char) 0xffff;
    data[3243] = (char) 0xffff;
    data[3244] = (char) 0xffff;
    data[3245] = (char) 0xffff;
    data[3246] = (char) 0xffff;
    data[3247] = (char) 0xffff;
    data[3248] = (char) 0xffff;
    data[3249] = (char) 0xffff;
    data[3250] = (char) 0xffff;
    data[3251] = (char) 0xffff;
    data[3252] = (char) 0xffff;
    data[3253] = (char) 0xffff;
    data[3254] = (char) 0xffff;
    data[3255] = (char) 0xffff;
    data[3256] = (char) 0xffff;
    data[3257] = (char) 0xffff;
    data[3258] = (char) 0xffff;
    data[3259] = (char) 0xffff;
    data[3260] = (char) 0xffff;
    data[3261] = (char) 0xffff;
    data[3262] = (char) 0xffff;
    data[3263] = (char) 0xffff;
    data[3264] = (char) 0xffff;
    data[3265] = (char) 0xffff;
    data[3266] = (char) 0xffff;
    data[3267] = (char) 0xffff;
    data[3268] = (char) 0xffff;
    data[3269] = (char) 0xffff;
    data[3270] = (char) 0xffff;
    data[3271] = (char) 0xffff;
    data[3272] = (char) 0xffff;
    data[3273] = (char) 0xffff;
    data[3274] = (char) 0xffff;
    data[3275] = (char) 0xffff;
    data[3276] = (char) 0xffff;
    data[3277] = (char) 0xffff;
    data[3278] = (char) 0xffff;
    data[3279] = (char) 0xffff;
    data[3280] = (char) 0xffff;
    data[3281] = (char) 0xffff;
    data[3282] = (char) 0xffff;
    data[3283] = (char) 0xffff;
    data[3284] = (char) 0xffff;
    data[3285] = (char) 0xffff;
    data[3286] = (char) 0xffff;
    data[3287] = (char) 0xffff;
    data[3288] = (char) 0xffff;
    data[3289] = (char) 0xffff;
    data[3290] = (char) 0xffff;
    data[3291] = (char) 0xffff;
    data[3292] = (char) 0xffff;
    data[3293] = (char) 0xffff;
    data[3294] = (char) 0xffff;
    data[3295] = (char) 0xffff;
    data[3296] = (char) 0xffff;
    data[3297] = (char) 0xffff;
    data[3298] = (char) 0xffff;
    data[3299] = (char) 0xffff;
    data[3300] = (char) 0xffff;
    data[3301] = (char) 0xffff;
    data[3302] = (char) 0xffff;
    data[3303] = (char) 0xffff;
    data[3304] = (char) 0xffff;
    data[3305] = (char) 0xffff;
    data[3306] = (char) 0xffff;
    data[3307] = (char) 0xffff;
    data[3308] = (char) 0xffff;
    data[3309] = (char) 0xffff;
    data[3310] = (char) 0xffff;
    data[3311] = (char) 0xffff;
    data[3312] = (char) 0xffff;
    data[3313] = (char) 0xffff;
    data[3314] = (char) 0xffff;
    data[3315] = (char) 0xffff;
    data[3316] = (char) 0xffff;
    data[3317] = (char) 0xffff;
    data[3318] = (char) 0xffff;
    data[3319] = (char) 0xffff;
    data[3320] = (char) 0xffff;
    data[3321] = (char) 0xffff;
    data[3322] = (char) 0xffff;
    data[3323] = (char) 0xffff;
    data[3324] = (char) 0xffff;
    data[3325] = (char) 0xffff;
    data[3326] = (char) 0xffff;
    data[3327] = (char) 0xffff;
    data[3328] = (char) 0xffff;
    data[3329] = (char) 0xffff;
    data[3330] = (char) 0xffff;
    data[3331] = (char) 0xffff;
    data[3332] = (char) 0xffff;
    data[3333] = (char) 0xffff;
    data[3334] = (char) 0xffff;
    data[3335] = (char) 0xffff;
    data[3336] = (char) 0xffff;
    data[3337] = (char) 0xffff;
    data[3338] = (char) 0xffff;
    data[3339] = (char) 0xffff;
    data[3340] = (char) 0xffff;
    data[3341] = (char) 0xffff;
    data[3342] = (char) 0xffff;
    data[3343] = (char) 0xffff;
    data[3344] = (char) 0xffff;
    data[3345] = (char) 0xffff;
    data[3346] = (char) 0xffff;
    data[3347] = (char) 0xffff;
    data[3348] = (char) 0xffff;
    data[3349] = (char) 0xffff;
    data[3350] = (char) 0xffff;
    data[3351] = (char) 0xffff;
    data[3352] = (char) 0xffff;
    data[3353] = (char) 0xffff;
    data[3354] = (char) 0xffff;
    data[3355] = (char) 0xffff;
    data[3356] = (char) 0xffff;
    data[3357] = (char) 0xffff;
    data[3358] = (char) 0xffff;
    data[3359] = (char) 0xffff;
    data[3360] = (char) 0xffff;
    data[3361] = (char) 0xffff;
    data[3362] = (char) 0xffff;
    data[3363] = (char) 0xffff;
    data[3364] = (char) 0xffff;
    data[3365] = (char) 0xffff;
    data[3366] = (char) 0xffff;
    data[3367] = (char) 0xffff;
    data[3368] = (char) 0xffff;
    data[3369] = (char) 0xffff;
    data[3370] = (char) 0xffff;
    data[3371] = (char) 0xffff;
    data[3372] = (char) 0xffff;
    data[3373] = (char) 0xffff;
    data[3374] = (char) 0xffff;
    data[3375] = (char) 0xffff;
    data[3376] = (char) 0xffff;
    data[3377] = (char) 0xffff;
    data[3378] = (char) 0xffff;
    data[3379] = (char) 0xffff;
    data[3380] = (char) 0xffff;
    data[3381] = (char) 0xffff;
    data[3382] = (char) 0xffff;
    data[3383] = (char) 0xffff;
    data[3384] = (char) 0xffff;
    data[3385] = (char) 0xffff;
    data[3386] = (char) 0xffff;
    data[3387] = (char) 0xffff;
    data[3388] = (char) 0xffff;
    data[3389] = (char) 0xffff;
    data[3390] = (char) 0xffff;
    data[3391] = (char) 0xffff;
    data[3392] = (char) 0xffff;
    data[3393] = (char) 0xffff;
    data[3394] = (char) 0xffff;
    data[3395] = (char) 0xffff;
    data[3396] = (char) 0xffff;
    data[3397] = (char) 0xffff;
    data[3398] = (char) 0xffff;
    data[3399] = (char) 0xffff;
    data[3400] = (char) 0xffff;
    data[3401] = (char) 0xffff;
    data[3402] = (char) 0xffff;
    data[3403] = (char) 0xffff;
    data[3404] = (char) 0xffff;
    data[3405] = (char) 0xffff;
    data[3406] = (char) 0xffff;
    data[3407] = (char) 0xffff;
    data[3408] = (char) 0xffff;
    data[3409] = (char) 0xffff;
    data[3410] = (char) 0xffff;
    data[3411] = (char) 0xffff;
    data[3412] = (char) 0xffff;
    data[3413] = (char) 0xffff;
    data[3414] = (char) 0xffff;
    data[3415] = (char) 0xffff;
    data[3416] = (char) 0xffff;
    data[3417] = (char) 0xffff;
    data[3418] = (char) 0xffff;
    data[3419] = (char) 0xffff;
    data[3420] = (char) 0xffff;
    data[3421] = (char) 0xffff;
    data[3422] = (char) 0xffff;
    data[3423] = (char) 0xffff;
    data[3424] = (char) 0xffff;
    data[3425] = (char) 0xffff;
    data[3426] = (char) 0xffff;
    data[3427] = (char) 0xffff;
    data[3428] = (char) 0xffff;
    data[3429] = (char) 0xffff;
    data[3430] = (char) 0xffff;
    data[3431] = (char) 0xffff;
    data[3432] = (char) 0xffff;
    data[3433] = (char) 0xffff;
    data[3434] = (char) 0xffff;
    data[3435] = (char) 0xffff;
    data[3436] = (char) 0xffff;
    data[3437] = (char) 0xffff;
    data[3438] = (char) 0xffff;
    data[3439] = (char) 0xffff;
    data[3440] = (char) 0xffff;
    data[3441] = (char) 0xffff;
    data[3442] = (char) 0xffff;
    data[3443] = (char) 0xffff;
    data[3444] = (char) 0xffff;
    data[3445] = (char) 0xffff;
    data[3446] = (char) 0xffff;
    data[3447] = (char) 0xffff;
    data[3448] = (char) 0xffff;
    data[3449] = (char) 0xffff;
    data[3450] = (char) 0x000f;
    data[3984] = (char) 0xffff;
    data[3985] = (char) 0xffff;
    data[3986] = (char) 0xffff;
    data[3987] = (char) 0xffff;
    data[3988] = (char) 0xffff;
    data[3989] = (char) 0xffff;
    data[3990] = (char) 0xffff;
    data[3991] = (char) 0xffff;
    data[3992] = (char) 0xffff;
    data[3993] = (char) 0xffff;
    data[3994] = (char) 0xffff;
    data[3995] = (char) 0xffff;
    data[3996] = (char) 0xffff;
    data[3997] = (char) 0xffff;
    data[3998] = (char) 0xffff;
    data[3999] = (char) 0xffff;
    data[4000] = (char) 0xffff;
    data[4001] = (char) 0xffff;
    data[4002] = (char) 0x3fff;
    data[4016] = (char) 0x007f;
    data[4017] = (char) 0x80f8;
    data[4018] = (char) 0xfdff;
    data[4019] = (char) 0x5f7f;
    data[4020] = (char) 0xffdb;
    data[4021] = (char) 0xffff;
    data[4022] = (char) 0xffff;
    data[4023] = (char) 0xffff;
    data[4024] = (char) 0xffff;
    data[4025] = (char) 0xffff;
    data[4026] = (char) 0xffff;
    data[4027] = (char) 0x0003;
    data[4029] = (char) 0xfff8;
    data[4030] = (char) 0xffff;
    data[4031] = (char) 0xffff;
    data[4032] = (char) 0xffff;
    data[4033] = (char) 0xffff;
    data[4034] = (char) 0xffff;
    data[4035] = (char) 0xffff;
    data[4036] = (char) 0xffff;
    data[4037] = (char) 0xffff;
    data[4038] = (char) 0xffff;
    data[4039] = (char) 0xffff;
    data[4040] = (char) 0xffff;
    data[4041] = (char) 0xffff;
    data[4042] = (char) 0xffff;
    data[4043] = (char) 0xffff;
    data[4044] = (char) 0xffff;
    data[4045] = (char) 0xffff;
    data[4046] = (char) 0xffff;
    data[4047] = (char) 0xffff;
    data[4048] = (char) 0xffff;
    data[4049] = (char) 0xffff;
    data[4050] = (char) 0xffff;
    data[4051] = (char) 0x3fff;
    data[4053] = (char) 0xffff;
    data[4054] = (char) 0xffff;
    data[4055] = (char) 0xffff;
    data[4056] = (char) 0xffff;
    data[4057] = (char) 0xfffc;
    data[4058] = (char) 0xffff;
    data[4059] = (char) 0xffff;
    data[4060] = (char) 0x00ff;
    data[4063] = (char) 0x0fff;
    data[4071] = (char) 0xffd7;
    data[4072] = (char) 0xffff;
    data[4073] = (char) 0xffff;
    data[4074] = (char) 0xffff;
    data[4075] = (char) 0xffff;
    data[4076] = (char) 0xffff;
    data[4077] = (char) 0xffff;
    data[4078] = (char) 0xffff;
    data[4079] = (char) 0x1fff;
    data[4082] = (char) 0xfffe;
    data[4083] = (char) 0x07ff;
    data[4084] = (char) 0xfffe;
    data[4085] = (char) 0x07ff;
    data[4086] = (char) 0xffc0;
    data[4087] = (char) 0xffff;
    data[4088] = (char) 0xffff;
    data[4089] = (char) 0xffff;
    data[4090] = (char) 0xffff;
    data[4091] = (char) 0x7fff;
    data[4092] = (char) 0xfcfc;
    data[4093] = (char) 0x1cfc;
    data[4100] = (char) 0xfffe;
    data[4101] = (char) 0x07ff;
    data[4102] = (char) 0xfffe;
    data[4103] = (char) 0x07ff;
    data[4106] = (char) 0x0400;
    data[4107] = (char) 0x0420;
    data[4108] = (char) 0xffff;
    data[4109] = (char) 0xff7f;
    data[4110] = (char) 0xffff;
    data[4111] = (char) 0xff7f;
    data[4112] = (char) 0xffff;
    data[4113] = (char) 0xffff;
    data[4114] = (char) 0xffff;
    data[4115] = (char) 0xffff;
    data[4116] = (char) 0xffff;
    data[4117] = (char) 0xffff;
    data[4118] = (char) 0xffff;
    data[4119] = (char) 0xffff;
    data[4120] = (char) 0xffff;
    data[4121] = (char) 0xffff;
    data[4122] = (char) 0xffff;
    data[4123] = (char) 0xffff;
    data[4124] = (char) 0xffff;
    data[4125] = (char) 0xffff;
    data[4126] = (char) 0xffff;
    data[4127] = (char) 0xfc3f;
    data[4128] = (char) 0xffff;
    data[4129] = (char) 0x00ff;
    data[4133] = (char) 0xffff;
    data[4134] = (char) 0xffff;
    data[4135] = (char) 0xffff;
    data[4136] = (char) 0xffff;
    data[4137] = (char) 0xffff;
    data[4138] = (char) 0x01ff;
    data[4139] = (char) 0xf9ff;
    data[4140] = (char) 0x0003;
    data[4141] = (char) 0x0003;
    data[4142] = (char) 0x001f;
    data[4151] = (char) 0x0400;
    data[4152] = (char) 0xd740;
    data[4153] = (char) 0xffff;
    data[4154] = (char) 0xfffb;
    data[4155] = (char) 0xffff;
    data[4156] = (char) 0x7fff;
    data[4157] = (char) 0x547f;
    data[4158] = (char) 0x00fd;

  }

  public static Bits white;
  static void white_f()
  {
    char[] data = new char[4159];
    white = new Bits(data);
    data[0] = (char) 0x3e00;
    data[1] = (char) 0xf000;
    data[2] = (char) 0x0001;
    data[512] = (char) 0x0fff;
    data[514] = (char) 0x0300;
    data[768] = (char) 0x0001;
    data[4096] = (char) 0x3e00;
    data[4097] = (char) 0xf000;
    data[4098] = (char) 0x0001;

  }

  public static Bits punct;
  static void punct_f()
  {
    char[] data = new char[4159];
    punct = new Bits(data);
    data[2] = (char) 0xf7ee;
    data[3] = (char) 0x8c00;
    data[4] = (char) 0x0001;
    data[5] = (char) 0xb800;
    data[7] = (char) 0x2800;
    data[10] = (char) 0x2802;
    data[11] = (char) 0x8880;
    data[55] = (char) 0x4030;
    data[56] = (char) 0x0080;
    data[85] = (char) 0xfc00;
    data[88] = (char) 0x0200;
    data[91] = (char) 0x4000;
    data[92] = (char) 0x0009;
    data[95] = (char) 0x0018;
    data[96] = (char) 0x1000;
    data[97] = (char) 0x8800;
    data[102] = (char) 0x3c00;
    data[109] = (char) 0x0010;
    data[150] = (char) 0x0030;
    data[151] = (char) 0x0001;
    data[226] = (char) 0x8000;
    data[229] = (char) 0x0c00;
    data[234] = (char) 0x8000;
    data[240] = (char) 0xfff0;
    data[241] = (char) 0x0007;
    data[243] = (char) 0x3c00;
    data[248] = (char) 0x0020;
    data[271] = (char) 0x0800;
    data[513] = (char) 0xffff;
    data[514] = (char) 0x00ff;
    data[515] = (char) 0xffff;
    data[516] = (char) 0x006f;
    data[519] = (char) 0x6000;
    data[520] = (char) 0x6000;
    data[562] = (char) 0x0600;
    data[768] = (char) 0xff4e;
    data[769] = (char) 0xfff3;
    data[771] = (char) 0x0001;
    data[783] = (char) 0x0800;
    data[4051] = (char) 0xc000;
    data[4067] = (char) 0xffff;
    data[4068] = (char) 0xfe1f;
    data[4069] = (char) 0xfff7;
    data[4070] = (char) 0x0d0b;
    data[4080] = (char) 0xf7ee;
    data[4081] = (char) 0x8c00;
    data[4082] = (char) 0x0001;
    data[4083] = (char) 0xb800;
    data[4085] = (char) 0x2800;
    data[4086] = (char) 0x003e;
    data[4098] = (char) 0xf7ee;
    data[4099] = (char) 0x8c00;
    data[4100] = (char) 0x0001;
    data[4101] = (char) 0xb800;
    data[4103] = (char) 0x2800;
    data[4106] = (char) 0x2802;
    data[4107] = (char) 0x8880;
    data[4151] = (char) 0x4030;
    data[4152] = (char) 0x0080;

  }
}
