/*
 * Jalview - A Sequence Alignment Editor and Viewer
 * Copyright (C) 2007 AM Waterhouse, J Procter, G Barton, M Clamp, S Searle
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */
package jalview.io;

import java.io.*;
import java.net.*;

public class FileParse
{
  public File inFile;
  protected String type;
  protected BufferedReader dataIn;

  public FileParse()
  {
  }

  public FileParse(String fileStr, String type)
      throws MalformedURLException, IOException
  {
    this.type = type;

    if (type.equals(AppletFormatAdapter.FILE))
    {
      this.inFile = new File(fileStr);
      dataIn = new BufferedReader(new FileReader(fileStr));
    }
    else if (type.equals(AppletFormatAdapter.URL))
    {
      URL url = new URL(fileStr);
      dataIn = new BufferedReader(new InputStreamReader(url.openStream()));
    }
    else if (type.equals(AppletFormatAdapter.PASTE))
    {
      dataIn = new BufferedReader(new StringReader(fileStr));
    }
    else if (type.equals(AppletFormatAdapter.CLASSLOADER))
    {
      java.io.InputStream is = getClass().getResourceAsStream("/" + fileStr);
      if (is != null)
      {
        dataIn = new BufferedReader(new java.io.InputStreamReader(is));
      }
    }
  }

  public String nextLine()
      throws IOException
  {
    return dataIn.readLine();
  }
}
